ROUND2 equ 10

slices_counter_tri:
;  Procedure counts slices of overlapped transparent triangles, each
;  counter as byte, each pixel have own counter.--------------------
;  ----------------in - eax - x1 shl 16 + y1 -----------------------
;  -------------------- ebx - x2 shl 16 + y2 -----------------------
;  -------------------- ecx - x3 shl 16 + y3 -----------------------
;  -------------------- edi - pointer to counter buffer ------------
; --------------------- Before calculating first triangle, buff must
; --------------------- be zeroed. ---------------------------------

.sct_x1     equ [ebp-2]
.sct_y1     equ [ebp-4]
.sct_x2     equ [ebp-6]
.sct_y2     equ [ebp-8]
.sct_x3     equ [ebp-10]
.sct_y3     equ [ebp-12]

.sct_dx12   equ dword[ebp-20]
.sct_dx13   equ dword[ebp-24]
.sct_dx23   equ dword[ebp-28]
.sct_buff   equ [ebp-32]


       push    ebp
       mov     ebp,esp
       sub     esp,128
     .sct_sort2:
        cmp     ax,bx
        jle     .sct_sort1
        xchg    eax,ebx
      .sct_sort1:
        cmp     bx,cx
        jle     .sct_sort3
        xchg    ebx,ecx
        jmp     .sct_sort2
      .sct_sort3:
        mov     .sct_y1,eax            ; store triangle coordinates in user friendly variables
        mov     .sct_y2,ebx
        mov     .sct_y3,ecx

        mov     .sct_buff,edi

         mov      edx,80008000h  ; eax,ebx,ecx are ANDd together into edx which means that
         and      edx,ebx        ; if *all* of them are negative a sign flag is raised
         and      edx,ecx
         and      edx,eax
         test     edx,80008000h  ; Check both X&Y at once
         jne      .sct_loop2_end

        mov     bx,.sct_y2       ; calc delta 12
        sub     bx,.sct_y1
        jnz     .sct_dx12_make
        mov     .sct_dx12,0
        jmp     .sct_dx12_done
   .sct_dx12_make:
        mov     ax,.sct_x2
        sub     ax,.sct_x1
        cwde
        movsx   ebx,bx
        shl     eax,ROUND2
        cdq
        idiv    ebx
        mov     .sct_dx12,eax


  .sct_dx12_done:
        mov     bx,.sct_y3       ; calc delta 13
        sub     bx,.sct_y1
        jnz     .sct_dx13_make
        mov     .sct_dx13,0
        jmp     .sct_dx13_done
   .sct_dx13_make:
        mov     ax,.sct_x3
        sub     ax,.sct_x1
        cwde
        movsx   ebx,bx
        shl     eax,ROUND2
        cdq
        idiv    ebx
        mov     .sct_dx13,eax

    .sct_dx13_done:
        mov     bx,.sct_y3       ; calc delta 23
        sub     bx,.sct_y2
        jnz     .sct_dx23_make
        mov     .sct_dx23,0
      ;  mov     .sct_dz23,0
        jmp     .sct_dx23_done
   .sct_dx23_make:
        mov     ax,.sct_x3
        sub     ax,.sct_x2
        cwde
        movsx   ebx,bx
        shl     eax,ROUND2
        cdq
        idiv    ebx
        mov     .sct_dx23,eax


    .sct_dx23_done:
        movsx   eax,word .sct_x1
        shl     eax,ROUND2    ; eax - cur x1
        mov     ebx,eax       ; ebx - cur x2

        mov     cx,.sct_y1
        cmp     cx,.sct_y2
        jge     .sct_loop1_end
     .sct_loop1:

        pushad
        sar     ebx,ROUND2
        sar     eax,ROUND2
        mov     edi,.sct_buff
        call    counter_slices_line

        popad
        add     eax,.sct_dx13
        add     ebx,.sct_dx12

        add     cx,1
        cmp     cx,.sct_y2
        jl      .sct_loop1

    .sct_loop1_end:

        movsx   ebx,word .sct_x2
        shl     ebx,ROUND2

        mov     cx,.sct_y2
        cmp     cx,.sct_y3
        jge     .sct_loop2_end
     .sct_loop2:
        pushad

        sar     ebx,ROUND2
        sar     eax,ROUND2
        mov     edi,.sct_buff

        call    counter_slices_line

        popad

        add     eax,.sct_dx13
        add     ebx,.sct_dx23



        add     cx,1
        cmp     cx,.sct_y3
        jl      .sct_loop2
     .sct_loop2_end:

        add  esp,128
        pop  ebp

ret

counter_slices_line:
;----------------------------------------------------
;--------------- eax - x1 ---------------------------
;--------------- ebx - x2 ---------------------------
;--------------- ecx - y-----------------------------
;--------------- edi - pointer to buff --------------

.scl_x2 equ  [ebp-4]
.scl_x1 equ  [ebp-8]
.scl_s_buf  equ [ebp-12]
.scl_y      equ [ebp-16]


     push       ebp
     mov        ebp,esp
     sub        esp,64
     or         cx,cx
     jle        .scl_l_quit

     cmp        cx,[yres_var]
     jge        .scl_l_quit

     movzx      ecx,cx
     mov        .scl_s_buf,edi
     cmp        eax,ebx
     je         .scl_l_quit
     jl         .scl_l_ok

     xchg       eax,ebx
   .scl_l_ok:

     cmp        ax,[xres_var]
     jge        .scl_l_quit
     cmp        bx,0
     jle        .scl_l_quit

     mov        .scl_x1,eax
     mov        .scl_x2,ebx

     sub        ebx,eax

     movzx      edx,word[xres_var]
     cmp        eax,1
     jge        @f
;     mov        eax,.scl_x1
;     neg        eax
     mov        dword .scl_x1,0
;     movzx      edx,word[xres_var]
;     sub        edx,1
   @@:
     cmp        .scl_x2,edx
     jl         @f
     mov        .scl_x2,edx

    @@:
;     movzx      edx,word[xres_var]
     mov        edi,.scl_s_buf

     mov        eax,ecx  ; y
     mul        edx
     add        eax,.scl_x1
     add        edi,eax

     mov        ecx,.scl_x2
     sub        ecx,.scl_x1
     shr     ecx,1
     jnc     @f
     movd    xmm0,[edi]
     paddusb xmm0,[sli_cnt_const]
     movd    eax,xmm0
     mov     [edi],al
     add     edi,1
     jecxz   .scl_l_quit
   @@:
     shr     ecx,1
     jnc     @f
     movd    xmm0,[edi]
     paddusb xmm0,[sli_cnt_const]
     movd    eax,xmm0
     mov     [edi],ax
     add     edi,2
     jecxz   .scl_l_quit
   @@:
     shr     ecx,1
     jnc     @f
     movd    xmm0,[edi]
     paddusb xmm0,[sli_cnt_const]
     movd    [edi],xmm0
     add     edi,4
     jecxz   .scl_l_quit
   @@:
     movq    xmm0,[edi]
     paddusb xmm0,[sli_cnt_const]  ; broadcasted db 1
     movq    [edi],xmm0
     add     edi,8
     sub     ecx,1     ; for large triangles
     jnz       @b
  .scl_l_quit:
     mov       esp,ebp
     pop       ebp
ret
