; drawing single Bezier curve procedures
; author : Maciej Guba aka macgub
; web	 : http://macgub.vxm.pl
draw_curve:
;in   esi - ptr to Bezier point list
    .Bez_cur_ptr equ [ebp-4]
    push  ebp
    mov   ebp,esp
    sub   esp,64

    mov .Bez_cur_ptr, esi
if 0 ;	Ext >= AVX
    fninit
    fld1
    fidiv	  [maxcountervar]
    fst 	  [step]
    vbroadcastss  ymm0,[step]
    vmulps	  ymm1,ymm0,[const8]
    vmovaps	  [step8],ymm1

    vmulps	  ymm0,ymm0,[const1234]  ;5678
    vmovaps	  [t1],ymm0
    movzx	  eax,[maxcountervar]
    mov 	  ebx,eax
    shr 	  eax,3
    and 	  ebx,0x00000007
    mov 	  [rest],ebx
  .oop:
    push     eax

    call     calc_voxelAVX     ; 8 3d points at once


    pushad
    mov      ecx,XRES
    movaps   xmm0,[Bpy1]
;    minps    xmm0,[maxy]
;    maxps    xmm0,[minxy]
;    minss    xmm0,[maxy]
;    maxss    xmm0,[minxy]
    cvtss2si eax,xmm0
    movaps   xmm1,[Bpx1]
;    minps    xmm1,[maxx]
;    maxps    xmm1,[minxy]
;    minss    xmm1,[maxx]
;    maxss    xmm1,[minxy]
    cvtss2si ebx,xmm1
    mul      ecx
    add      eax,ebx
    shl      eax,2
    add      eax,buffer
    mov      dword [eax],0x000000ff
    psrldq   xmm0,4
;    minss    xmm0,[maxy]
;    maxss    xmm0,[minxy]
    cvtss2si eax,xmm0
    psrldq   xmm1,4
;    minss    xmm1,[maxx]
;    maxss    xmm1,[minxy]
    cvtss2si ebx,xmm1
    mul      ecx
    add      eax,ebx
    shl      eax,2
    add      eax,Bbuffer
    mov      dword [eax],0x000000ff
    psrldq   xmm0,4
;    minss    xmm0,[maxy]
;    maxss    xmm0,[minxy]
    cvtss2si eax,xmm0
    psrldq   xmm1,4
;    minss    xmm1,[maxx]
;    maxss    xmm1,[minxy]
    cvtss2si ebx,xmm1
    mul      ecx
    add      eax,ebx
    shl      eax,2
    add      eax,buffer
    mov      dword [eax],0x000000ff
    psrldq   xmm0,4
;    minss    xmm0,[maxy]
;    maxss    xmm0,[minxy]
    cvtss2si eax,xmm0
    psrldq   xmm1,4
;    minss    xmm1,[maxx]
;    maxss    xmm1,[minxy]
    cvtss2si ebx,xmm1
    mul      ecx
    add      eax,ebx
    shl      eax,2
    add      eax,Bbuffer
    mov      dword [eax],0x000000ff

    movaps   xmm0,[py5]
;    minps    xmm0,[maxx]
;    maxps    xmm0,[minxy]
    cvtss2si eax,xmm0
    movaps   xmm1,[px5]
;    minps    xmm1,[maxy]
;    maxps    xmm1,[minxy]
    cvtss2si ebx,xmm1
    mul      ecx
    add      eax,ebx
    shl      eax,2
    add      eax,buffer
    mov      dword [eax],0x000000ff
    psrldq   xmm0,4
    cvtss2si eax,xmm0
    psrldq   xmm1,4
    cvtss2si ebx,xmm1
    mul      ecx
    add      eax,ebx
    shl      eax,2
    add      eax,buffer
    mov      dword [eax],0x000000ff
    psrldq   xmm0,4
    cvtss2si eax,xmm0
    psrldq   xmm1,4
    cvtss2si ebx,xmm1
    mul      ecx
    add      eax,ebx
    shl      eax,2
    add      eax,Bbuffer
    mov      dword [eax],0x000000ff
    psrldq   xmm0,4
    cvtss2si eax,xmm0
    psrldq   xmm1,4
    cvtss2si ebx,xmm1
    mul      ecx
    add      eax,ebx
    shl      eax,2
    add      eax,Bbuffer
    mov      dword [eax],0x000000ff

    popad





    vmovaps  ymm4,[t1]
    vaddps   ymm4,ymm4,[step8]

    vmovaps [t1],ymm4
    pop    eax
    dec    eax
    or	   eax,eax   ;[maxcountervar]
    jnz    .oop
else


    fninit
    fld1
    fidiv  [maxcountervar]
    fstp   [step]
    movss  xmm0,[step]
    shufps xmm0,xmm0,0
    mulps  xmm0,[const4]
    movaps [step4],xmm0

    movss  xmm0,[step]
    shufps xmm0,xmm0,0
    mulps  xmm0,[const1234]
    movaps [t1],xmm0
    movzx  eax,[maxcountervar]
    mov    ebx,eax

    shr    eax,2
    and    ebx,0x00000003    ; ebx -> rest
    mov    [rest],ebx
;     mov   [global_points_counter],0
  .oop:
    push   eax

    call   calc_abcd
    call   calc_voxel


    mov      edi,[global_points_counter]    ; do points list
    shl      edi,2
    lea      edi,[edi*3]
    add      edi,.Bez_cur_ptr

    movaps   xmm0,[Bpx1]
    movaps   xmm1,[Bpy1]
    movaps   xmm2,[Bpz1]
    mov      ecx,4

  @@:
    movss  [edi],xmm0
    movss  [edi+4],xmm1
    movss  [edi+8],xmm2
    psrldq xmm0,4
    psrldq xmm1,4
    psrldq xmm2,4
    add    edi,12
    loop   @b
    add    [global_points_counter],4


.draw_points:
;===alternative2
    pushad
    mov      ecx,BXRES
    movaps   xmm0,[Bpy1]
;    minps    xmm0,[maxy]
;    maxps    xmm0,[minxy]
;    minss    xmm0,[maxy]
;    maxss    xmm0,[minxy]
    cvtss2si eax,xmm0
    movaps   xmm1,[Bpx1]
;    minps    xmm0,[maxx]
;    maxps    xmm0,[minxy]
;    minss    xmm0,[maxx]
;    maxss    xmm0,[minxy]
    cvtss2si ebx,xmm1
    mul      ecx
    add      eax,ebx
    shl      eax,2
    add      eax,Bbuffer
    mov      dword [eax],0x00ffffff

    psrldq   xmm0,4
;    minss    xmm0,[maxy]
;    maxss    xmm0,[minxy]
    cvtss2si eax,xmm0
    psrldq   xmm1,4
;    minss    xmm1,[maxx]
;    maxss    xmm1,[minxy]
    cvtss2si ebx,xmm1
    mul      ecx
    add      eax,ebx
    shl      eax,2
    add      eax,Bbuffer
    mov      dword [eax],0x00ffffff

    psrldq   xmm0,4
;    minss    xmm0,[maxy]
;    maxss    xmm0,[minxy]
    cvtss2si eax,xmm0
    psrldq   xmm1,4
;    minss    xmm1,[maxx]
;    maxss    xmm1,[minxy]
    cvtss2si ebx,xmm1
    mul      ecx
    add      eax,ebx
    shl      eax,2
    add      eax,Bbuffer
    mov      dword [eax],0x00ffffff

    psrldq   xmm0,4
;    minss    xmm0,[maxy]
;    maxss    xmm0,[minxy]
    cvtss2si eax,xmm0
    psrldq   xmm1,4
;    minss    xmm1,[maxx]
;    maxss    xmm1,[minxy]
    cvtss2si ebx,xmm1
    mul      ecx
    add      eax,ebx
    shl      eax,2
    add      eax,Bbuffer
    mov      dword [eax],0x00ffffff
    popad






    movaps xmm4,[t1]
    addps  xmm4,[step4]

    movups [t1],xmm4
    pop    eax
    dec    eax
    or	   eax,eax   ;[maxcountervar]
    jnz    .oop
;    mov   [Bsave_flag],0

end if









  .draw_last:
    mov    eax,[rest]
    or	   eax,eax
    jz	   .end
    push   dword[t4]
    pop    [t]
 .loop_rest:
    push   eax

    call   calc_abcd1
    call   calc_voxel1

    pushad
    movzx  ecx,[xres_var]  ;XRES
    movss  xmm0,[py]
;    minss    xmm0,[maxy]
;    maxss    xmm0,[minxy]
    cvtss2si eax,xmm0
    movss   xmm1,[px]
;    minss    xmm1,[maxx]
;    maxss    xmm1,[minxy]
    cvtss2si ebx,xmm1
    mul      ecx
    add      eax,ebx
    shl      eax,2
    add      eax,Bbuffer
    mov      dword [eax],0x00ffffff
    popad

    movss  xmm4,[t]
    addss  xmm4,[step4]

    movss  [t],xmm4
    pop    eax
    dec    eax
    or	   eax,eax   ;[maxcountervar]
    jnz    .loop_rest
  .end:
   mov	 esp,ebp
   pop	 ebp
ret
if 0 ; Ext >= AVX
calc_voxelAVX:
  vbroadcastss	ymm0,[const1]
  vmovaps	ymm1,[t1]
  vsubps	ymm0,ymm0,ymm1
  vmovaps	ymm3,ymm0
  vmovaps	ymm4,ymm0
  vmulps	ymm4,ymm4,ymm4
  vmulps	ymm7,ymm3,ymm4
 ; vmovaps	 [a1],ymm3
  vmulps	ymm4,ymm4,[const3]
  vmulps	ymm6,ymm4,[t1]
 ; vmovaps	 [b1],ymm4
  vmulps	ymm0,ymm0,[const3]
  vmulps	ymm1,ymm1,ymm1
  vmulps	ymm5,ymm0,ymm1
 ; vmovaps	 [c1],ymm0
  vmulps	ymm1,ymm1,[t1]
  vmovaps	ymm4,ymm1

  vbroadcastss ymm0,[Bp1x]
  vmulps       ymm0,ymm0,ymm7 ;[a1]
  vbroadcastss ymm1,[Bp2x]
  vmulps       ymm1,ymm1,ymm6 ;[b1]
  vbroadcastss ymm2,[Bp3x]
  vmulps       ymm2,ymm2,ymm5 ;[c1]
  vbroadcastss ymm3,[Bp4x]
  vmulps       ymm3,ymm3,ymm4 ;[d1]
  vaddps       ymm0,ymm0,ymm1
  vaddps       ymm2,ymm2,ymm3
  vaddps       ymm0,ymm0,ymm2
  vmovaps      [Bpx1],ymm0

  vbroadcastss ymm0,[Bp1y]
  vmulps       ymm0,ymm0,ymm7 ;[a1]
  vbroadcastss ymm1,[Bp2y]
  vmulps       ymm1,ymm1,ymm6 ;[b1]
  vbroadcastss ymm2,[Bp3y]
  vmulps       ymm2,ymm2,ymm5 ;[c1]
  vbroadcastss ymm3,[Bp4y]
  vmulps       ymm3,ymm3,ymm4 ;[d1]
  vaddps       ymm0,ymm0,ymm1
  vaddps       ymm2,ymm2,ymm3
  vaddps       ymm0,ymm0,ymm2
  vmovaps      [Bpy1],ymm0

  vbroadcastss ymm0,[Bp1z]
  vmulps       ymm0,ymm0,ymm7 ;[a1]
  vbroadcastss ymm1,[Bp2z]
  vmulps       ymm1,ymm1,ymm6 ;[b1]
  vbroadcastss ymm2,[Bp3z]
  vmulps       ymm2,ymm2,ymm5 ;[c1]
  vbroadcastss ymm3,[Bp4z]
  vmulps       ymm3,ymm3,ymm4 ;[d1]
  vaddps       ymm0,ymm0,ymm1
  vaddps       ymm2,ymm2,ymm3
  vaddps       ymm0,ymm0,ymm2
  vmovaps      [Bpz1],ymm0

ret
else

calc_abcd_spline:
			  ; a = 1/6*(1-3*t+3*t^2-t^3)
			  ; b = 1/6*(4-6*t^2+3*t^3)
			  ; c = 1/6*(1+3*t+3t^2-3t^3)
			  ; d = 1/6*(t^3)
  movaps  xmm0,[const1]
  movaps  xmm1,[t1]
  movaps  xmm2,xmm1
  mulps   xmm2,xmm2
  movaps  xmm3,xmm2
  mulps   xmm3,xmm1
  mulps   xmm2,[const3]
  mulps   xmm1,[const3]
  subps   xmm0,xmm1
  addps   xmm0,xmm2
  subps   xmm0,xmm3
  mulps   xmm0,[constrecipr6]
  movaps  [a1],xmm0
  movaps  xmm0,[const4]
  subps   xmm0,xmm2
  subps   xmm0,xmm2
  movaps  xmm4,xmm3
  mulps   xmm4,[const3]
  addps   xmm0,xmm4
  mulps   xmm0,[constrecipr6]
  movaps  [b1],xmm0
  movaps  xmm0,[const1]
  addps   xmm0,xmm1
  addps   xmm0,xmm2
  subps   xmm0,xmm4
  mulps   xmm0,[constrecipr6]
  movaps  [c1],xmm0
  mulps   xmm3,[constrecipr6]
  movaps  [d1],xmm3
ret

calc_abcd:

 movaps   xmm0,[const1]
 movaps   xmm1,[t1]
 subps	  xmm0,xmm1				    ;	a  = (1-t)^3
 movaps   xmm7,xmm0				    ;	b  = 3*(1-t)^2*t
 movaps   xmm6,xmm0				    ;	c  = 3*(1-t)*t^2
 mulps	  xmm6,xmm6				    ;	d  = t^3
 mulps	  xmm7,xmm6
 movaps   [a1],xmm7
 mulps	  xmm6,[const3]
 mulps	  xmm6,[t1]
 movaps   [b1],xmm6
 mulps	  xmm0,[const3]
 mulps	  xmm1,xmm1
 mulps	  xmm0,xmm1
 movaps   [c1],xmm0
 mulps	  xmm1,[t1]
 movaps   [d1],xmm1

ret


calc_voxel:

  movss   xmm0,[Bp1x]
  shufps  xmm0,xmm0,0
  mulps   xmm0,[a1]	  ;   px = a*p1x + b*p2x + c*p3x + d*p4x
  movss   xmm1,[Bp2x]
  shufps  xmm1,xmm1,0
  mulps   xmm1,[b1]
  movss   xmm2,[Bp3x]
  shufps  xmm2,xmm2,0
  mulps   xmm2,[c1]
  movss   xmm3,[Bp4x]
  shufps  xmm3,xmm3,0
  mulps   xmm3,[d1]
  addps   xmm0,xmm1
  addps   xmm2,xmm3
  addps   xmm0,xmm2
  movaps  [Bpx1],xmm0	 ;  4 x coordinates at once


  movss   xmm0,[Bp1y]
  shufps  xmm0,xmm0,0
  mulps   xmm0,[a1]	  ;   px = a*p1x + b*p2x + c*p3x + d*p4x
  movss   xmm1,[Bp2y]
  shufps  xmm1,xmm1,0
  mulps   xmm1,[b1]
  movss   xmm2,[Bp3y]
  shufps  xmm2,xmm2,0
  mulps   xmm2,[c1]
  movss   xmm3,[Bp4y]
  shufps  xmm3,xmm3,0
  mulps   xmm3,[d1]
  addps   xmm0,xmm1
  addps   xmm2,xmm3
  addps   xmm0,xmm2
  movaps  [Bpy1],xmm0	 ;  4 x coordinates at once


  movss   xmm7,[Bp1z]
  shufps  xmm7,xmm7,0
  mulps   xmm7,[a1]
  movss   xmm6,[Bp2z]
  shufps  xmm6,xmm6,0
  mulps   xmm6,[b1]
  movss   xmm5,[Bp3z]
  shufps  xmm5,xmm5,0
  mulps   xmm5,[c1]
  movss   xmm4,[Bp4z]
  shufps  xmm4,xmm4,0
  mulps   xmm4,[d1]
  addps   xmm4,xmm5
  addps   xmm6,xmm7
  addps   xmm4,xmm6
  movaps  [Bpz1],xmm4

ret
end if

draw_curve1:
    fninit
    fld1
    fidiv  [maxcountervar]
    fst    [step]
    fstp   [t]

    mov    ecx,1
  .oop:
    push   ecx

    call   calc_abcd1
    call   calc_voxel1
			    ; putpixel
    fld    [px]
    fistp  [ipx]
    fld    [py]
    fistp  [ipy]

    movzx  eax,[ipy]
    movzx  ebx,[ipx]
    movzx  edx,[xres_var]  ;XRES
    mul    edx
    add    eax,ebx
    shl    eax,2
    add    eax,Bbuffer
    mov    [eax],dword -1

    fld    [t]
    fadd   [step]
    fstp   [t]

    pop    ecx
    inc    ecx
    cmp    cx,[maxcountervar]
    jnz    .oop

ret


calc_abcd1:

 fninit 				 ;   a	= (1-t)^3
 fld1					 ;   b	= 3*(1-t)^2*t
 fsub  [t]				 ;   c	= 3*(1-t)*t^2
 fld   st				 ;   d	= t^3
 fmul  st,st0
 fmulp
 fstp  [a]
 fld1
 fsub  [t]
 fmul  st,st0
 fimul [i3]
 fmul  [t]
 fstp  [b]
 fld1
 fsub  [t]
 fmul  [t]
 fmul  [t]
 fimul [i3]
 fstp  [c]
 fld   [t]
 fmul  st,st0
 fmul  [t]
 fstp  [d]
ret

calc_voxel1:

  fninit
  fld	[Bp1x]
  fmul	[a]
  fld	[Bp2x]
  fmul	[b]
  faddp
  fld	[Bp3x]
  fmul	[c]
  faddp
  fld	[Bp4x]
  fmul	[d]
  faddp
  fstp	[px]

  fld	[Bp1y]
  fmul	[a]
  fld	[Bp2y]
  fmul	[b]
  faddp
  fld	[Bp3y]
  fmul	[c]
  faddp
  fld	[Bp4y]
  fmul	[d]
  faddp
  fstp	[py]

  fld	[Bp1z]
  fmul	[a]
  fld	[Bp2z]
  fmul	[b]
  faddp
  fld	[Bp3z]
  fmul	[c]
  faddp
  fld	[Bp4z]
  fmul	[d]
  faddp
  fstp	[pz]
ret



