CATMULL_SHIFT equ 8
ROUND2	equ 10


flat_triangle_z:
;  procedure drawing triangle with Z cordinate interpolation ------
;  (Catmull  alghoritm) , version with pararelized drawing main ---
;  loop using sse2 instruction - maskmovdqu------------------------
;  ----------------in - eax - x1 shl 16 + y1 ----------------------
;  -------------------- ebx - x2 shl 16 + y2 ----------------------
;  -------------------- ecx - x3 shl 16 + y3 ----------------------
;  -------------------- edx - color 0x00RRGGBB --------------------
;  -------------------- esi - pointer to Z-buffer -----------------
;  -------------------- edi - pointer to screen buffer-------------
;  -------------------- stack : z coordinates
;  -------------------- Z-buffer : each z variable as dword
;  -------------------- (Z coor. as word) shl CATMULL_SHIFT
.y_min	equ [ebp+12]
.y_max	equ [ebp+10]
.z1	equ [ebp+4]
.z2	equ [ebp+6]    ; each z coordinate as word integer
.z3	equ word[ebp+8]

.col	equ dword[ebp-4]
.x1	equ word[ebp-6]
.y1	equ word[ebp-8]
.x2	equ word[ebp-10]
.y2	equ word[ebp-12]
.x3	equ word[ebp-14]
.y3	equ [ebp-16]



.dx12	equ dword[ebp-20]
.dx13	equ dword[ebp-24]
.dz13	equ dword[ebp-28]
.dz12	equ dword[ebp-32]
.dx23	equ dword[ebp-36]
.dz23	equ dword[ebp-44]
.zz1	equ dword[ebp-48]
.zz2	equ dword[ebp-52]
	mov	ebp,esp

	push	edx	       ; store edx in variable .col
      .sort2:
	cmp	ax,bx
	jle	.sort1
      if 0
	movd	 xmm0,eax
	movd	 xmm2,eax
	movd	 xmm1,ebx
	movsx	 eax,word .z1
	movsx	 ebx,word .z2
	movd	 xmm3,eax
	movd	 xmm4,ebx
	movlhps  xmm0,xmm3
	movlhps  xmm1,xmm4
	movdqa	 xmm2,xmm0
	pcmpgtw  xmm0,xmm1
	pshuflw  xmm0,xmm0,0
	pshufd	 xmm0,xmm0,0
     ;   pandn    xmm0,xmm0
	movdqa	 xmm3,xmm0     ; xmm0 - mask
	pandn	 xmm3,xmm3     ; xmm3 - not mask
	movdqa	 xmm4,xmm3
	movdqa	 xmm5,xmm0
	pand	 xmm2,xmm0
	pand	 xmm3,xmm1
	por	 xmm3,xmm2    ; xmm3 - greater
	por	 xmm4,xmm1
	por	 xmm0,xmm5
	pand	 xmm0,xmm4

	movd	 eax,xmm0  ;    now eax and ebx  will be sorted
	movd	 ebx,xmm3

      end if

	xchg	eax,ebx
	mov	edx,.z1
	ror	edx,16
	mov	.z1,edx
      .sort1:
	cmp	bx,cx
	jle	.sort3
	xchg	ebx,ecx
	mov	edx,.z2
	ror	edx,16
	mov	.z2,edx


	jmp	.sort2
      .sort3:
	push	eax	       ; store triangle coordinates in user friendly variables
	push	ebx
	push	ecx
     ;   int3

	movups	xmm0,.y3		; check if at last only fragment
	pand	xmm0,[draw_thread_mask] ; of triangle is in visable area
	movd	xmm1,.y_max
	packssdw xmm0,xmm0
	pshuflw xmm2,xmm1,01010101b
	pshuflw xmm1,xmm1,0
	movdqa	xmm3,xmm0
	pcmpgtw xmm3,xmm2
	pcmpgtw xmm0,xmm1
	pxor	xmm0,xmm3
	pmovmskb eax,xmm0
	and	al,00111111b
	or	al,al
	jz     .ft_loop2_end

     ;    mov      edx,80008000h  ; eax,ebx,ecx are ANDd together into edx which means that
     ;    and      edx,ebx        ; if *all* of them are negative a sign flag is raised
     ;    and      edx,ecx
     ;    and      edx,eax
     ;    test     edx,80008000h  ; Check both X&Y at once
     ;    jne      .ft_loop2_end

       ;  cmp      ax,SIZE_Y
       ;  jle      @f
       ;  cmp      bx,SIZE_Y
       ;  jle      @f
       ;  cmp      cx,SIZE_Y
       ;  jge      @f
       ;  ror      eax,16
       ;  ror      ebx,16
       ;  ror      ecx,16
       ;  cmp      ax,SIZE_X
       ;  jle      @f
       ;  cmp      bx,SIZE_X
       ;  jle      @f
       ;  cmp      cx,SIZE_X
       ;  jle      @f
       ;  jmp      .ft_loop2_end
       ;@@:
	sub	esp,64 ;52+12

	mov	bx,.y2	     ; calc delta 12
	sub	bx,.y1
	jnz	.ft_dx12_make
	mov	.dx12,0
	mov	.dz12,0
	jmp	.ft_dx12_done
   .ft_dx12_make:
if 0
	mov	cx,.x2
	sub	cx,.x1	       ; version with two mul and one div
	movsx	ecx,cx
	movsx	ebx,bx

	mov	eax,65536
	cdq
	idiv	ebx
	mov	ebx,eax
	imul	ecx
	sar	eax,8
	mov	.dx12,eax

	mov	cx,.z2
	sub	cx,.z1
	movsx	ecx,cx
	mov	eax,ebx
	imul	ecx
	sar	eax,8
	mov	.dz12,eax
else
	mov	ax,.x2	     ; version with two div
	sub	ax,.x1
	cwde
	movsx	ebx,bx

	shl	eax,ROUND2
	cdq
	idiv	ebx
	mov	.dx12,eax

	mov	ax,.z2
	sub	ax,.z1
	cwde

	shl	eax,CATMULL_SHIFT
	cdq
	idiv	ebx
	mov	.dz12,eax
end if
  .ft_dx12_done:
	mov	bx,.y3	     ; calc delta 13
	sub	bx,.y1
	jnz	.ft_dx13_make
	mov	.dx13,0
	mov	.dz13,0
	jmp	.ft_dx13_done
   .ft_dx13_make:
if 0
	mov	cx,.x3
	sub	cx,.x1
	movsx	ecx,cx
	movsx	ebx,bx

	mov	eax,256
	cdq
	idiv	ebx
	mov	ebx,eax
	imul	ecx


;        shl     eax,ROUND2
;        cdq
;        idiv    ebx
	mov	.dx13,eax



;        mov     ax,.z2
;        sub     ax,.z1
;        cwde
	mov	cx,.z3
	sub	cx,.z1
	movsx	ecx,cx
	mov	eax,ebx
	imul	ecx
	mov	.dz13,eax
else
	mov	ax,.x3
	sub	ax,.x1
	cwde
	movsx	ebx,bx
	shl	eax,ROUND2
	cdq
	idiv	ebx
	mov	.dx13,eax

	mov	ax,.z3
	sub	ax,.z1
	cwde
	shl	eax,CATMULL_SHIFT
	cdq
	idiv	ebx
	mov	.dz13,eax
end if
    .ft_dx13_done:
	mov	bx,.y3	     ; calc delta 23
	sub	bx,.y2
	jnz	.gt_dx23_make
	mov	.dx23,0
	mov	.dz23,0
	jmp	.gt_dx23_done
   .gt_dx23_make:
	mov	ax,.x3
	sub	ax,.x2
	cwde
	movsx	ebx,bx
	shl	eax,ROUND2
	cdq
	idiv	ebx
	mov	.dx23,eax

	mov	ax,.z3
	sub	ax,.z2
	cwde
	shl	eax,CATMULL_SHIFT
	cdq
	idiv	ebx
	mov	.dz23,eax
    .gt_dx23_done:

	movsx	edx,word .z1
	shl	edx,CATMULL_SHIFT
	mov	.zz1,edx
	mov	.zz2,edx
	movsx	eax,.x1
	shl	eax,ROUND2    ; eax - x1
	mov	ebx,eax      ; ebx - x2

	mov	cx,.y1
	cmp	cx,.y2
	jge	.ft_loop1_end
     .ft_loop1:

	pushad
	push	word .y_min
	push	word .y_max
	push	.col
	push	cx	    ; y
	sar	ebx,ROUND2
	push	bx	    ; x2
	sar	eax,ROUND2
	push	ax	    ; x1

	push	.zz2	    ; z2 shl CATMULL_SHIFT
	push	.zz1	    ; z1 shl CATMULL_SHIFT

	call	flat_line_z

	popad

	add	eax,.dx13
	add	ebx,.dx12


	mov	edx,.dz13
	add	.zz1,edx
	mov	edx,.dz12
	add	.zz2,edx

	inc	cx
	cmp	cx,.y2
	jl	.ft_loop1
    .ft_loop1_end:

	movsx	edx,word .z2
	shl	edx,CATMULL_SHIFT
	mov	.zz2,edx
	movsx	ebx,.x2
	shl	ebx,ROUND2

	mov	cx,.y2
	cmp	cx,.y3
	jge	.ft_loop2_end
     .ft_loop2:
	pushad
	push	word .y_min
	push	word .y_max
	push	.col
	push	cx
	sar	ebx,ROUND2
	push	bx
	sar	eax,ROUND2
	push	ax	    ; x1

	push	.zz2	    ; z2 shl CATMULL_SHIFT
	push	.zz1	    ; z1 shl CATMULL_SHIFT

	call	flat_line_z

	popad

	add	eax,.dx13
	add	ebx,.dx23

	mov	edx,.dz13
	add	.zz1,edx
	mov	edx,.dz23
	add	.zz2,edx

	inc	cx
	cmp	cx,.y3
	jl	.ft_loop2
     .ft_loop2_end:

	mov esp,ebp
ret 10

flat_line_z:
;----------------
;-------------in edi - pointer to screen buffer ----------------------------------
;--------------- esi - pointer to z-buffer (each Z varible dword)-----------------
;----------stack - (each z coordinate shifted shl CATMULL_SHIFT)------------------
.z1 equ dword [ebp+4]
.z2 equ dword [ebp+8]
.x1 equ word  [ebp+12]
.x2 equ word  [ebp+14]
.y  equ word  [ebp+16]
.col equ dword [ebp+18]
.y_max equ word [ebp+22]
.y_min equ word [ebp+24]

.dz equ dword [ebp-4]
.dzIV  equ ebp-8
.dzIII equ ebp-12
.dzII  equ ebp-16
.dzI   equ ebp-20
.czIV  equ ebp-24
.czIII equ ebp-28
.czII  equ ebp-32
.czI   equ ebp-36
.rest  equ ebp-40
.first equ dword [ebp-44]
     mov	ebp,esp
;;     sub        esp,4
     mov	ax,.y
     cmp	ax,.y_min
     jl 	.fl_quit
     mov	bx,.y_max
     dec	bx
     cmp	ax,bx  ;SIZE_Y-1
     jg 	.fl_quit


     mov	ax,.x1
     cmp	ax,.x2
     je 	.fl_quit
     jl 	.fl_ok

     mov	 dx,.x2
     mov	 .x1,dx
     mov	 .x2,ax
     mov	 edx,.z1
     mov	 eax,.z2
     mov	 .z1,eax
     mov	 .z2,edx
   .fl_ok:
     mov	 ax,[xres_var]
 ;    sub        eax,BSIZE_X
     cmp	.x1,ax ;[xres_var] ;SIZE_X-1
     jg 	.fl_quit
     cmp	.x2,0
     jle	.fl_quit

     mov	eax,.z2
     sub	eax,.z1
     cdq
     mov	bx,.x2
     sub	bx,.x1
     movsx	ebx,bx
     idiv	ebx		; calculated delta - shifted .dz
     push	eax
     sub	esp,64

     cmp	.x1,0
     jge	@f
     movsx	ebx,.x1
     neg	ebx
     imul	ebx
     add	.z1,eax
     mov	.x1,0
    @@:
     mov	 ax,[xres_var]
     cmp	.x1,ax
     jl 	@f
     mov	.x2,ax
    @@:
     movzx	edx,[xres_var]
     movsx	eax,.y
     mul	edx		     ; edi = edi + (SIZE_X * y + x1)*4
     movsx	edx,.x1
     add	eax,edx
				     ; esi = esi + (SIZE_X * y + x1)*4
     shl	eax,2
     and	esi,0xfffffff0
     and	edi,0xfffffff0	 ;to be sure
     add	esi,eax
     add	edi,eax

     mov	cx,.x2
     sub	cx,.x1
     movzx	ecx,cx
  ;   and        esi,-2
  ;   and        edi,-2

     mov	ebx,.z1  ; ebx : curr. z
     mov	edx,.dz
     cmp	ecx,4
     jl 	.short_line

     mov	eax,.col
     or 	eax,0xff000000
     movd	xmm6,eax
     shufps	xmm6,xmm6,0
     mov	eax,edi
if 1   ; first non aligned pixels work
     and	eax,0x0000000f
     shr	eax,2
     or 	eax,eax
     jz 	.short_line

    .f_st:
  ;  int3
     cmp	ebx,[esi]	; draw first pixels non aligned
     jnl	@f
     movd      [edi],xmm6
     mov       [esi],ebx
   @@:
     add       edi,4
     add       esi,4
     add       ebx,edx
     sub       ecx,1
     sub       eax,1
     jnz       .f_st

end if
     cmp       ecx,0
     jz        .fl_quit



  .short_line:
     mov	[.dzI],edx
     mov	[.czI],ebx
     movd	xmm1,edx
     shufps	xmm1,xmm1,0
     pslld	xmm1,2


     add	ebx,edx
     mov	[.czII],ebx
     add	ebx,edx
     mov	[.czIII],ebx
     add	ebx,edx
     mov	[.czIV],ebx


     movups	xmm2,[.czI]
     mov	word [.rest],0
     shr	ecx,1
     jnc	@f
     add	word [.rest],1
  @@:
     shr	ecx,1
     jnc	@f
     add	word  [.rest],2
  @@:
     jecxz	.draw_last
   .ddraw:
     movdqu	xmm3,[esi]	  ; esi -> pointer to z buffer
     pcmpgtd	xmm3,xmm2;xmm5    ; packed compare Z buffer
     pmovmskb	eax,xmm3	  ; check cause if all bits are zeroed
     or 	eax,eax
     jz 	@f
if   (Ext=SSE2)|(Ext=SSE3)
     pandn	xmm3,xmm3
     movdqa	xmm5,xmm2
     movdqu	xmm4,[esi]
     movdqu	xmm0,[edi]
     movdqa	xmm7,xmm6   ; col
     pand	xmm0,xmm3
     pand	xmm4,xmm3
     por	xmm7,xmm0
     por	xmm5,xmm4
     movdqu	[edi],xmm7
     movdqu	[esi],xmm5
	 ; other version used non-temp hint
;     maskmovdqu xmm0,xmm3         ; draw color
;     xchg       esi,edi
;     maskmovdqu xmm2,xmm3         ; actulaize z buffer
;     xchg       esi,edi
else		  ;  sse4.1
     movaps	xmm7,xmm0
     movaps	xmm0,xmm3	  ; xmm0 - mask
     movaps	xmm6,[edi]
     pblendvb	xmm6,xmm7	  ; draw color
     movups	[edi],xmm6
     movups	xmm5,[esi]
     pblendvb	xmm5,xmm2	  ; actulaize z buffer
     movups	[esi],xmm5
     movaps	xmm0,xmm7
end if


   @@:
     add	edi,16
     add	esi,16
     paddd	xmm2,xmm1
     sub	ecx,1
     jnz       .ddraw
   .draw_last:
     movzx	ecx,word[.rest]
     jecxz	.fl_quit
   ;  psrldq     xmm2,12
     movd	ebx,xmm2  ; ebx -> cur z
     mov	eax,.col
     or 	eax,0xff000000
   .ddraw_last:
     cmp	ebx,dword[esi]
     jge	@f
     mov	dword[edi],eax
     mov	dword[esi],ebx
   @@:
     add	ebx,.dz
     add	esi,4
     add	edi,4
     loop	.ddraw_last

   .fl_quit:

     mov   esp,ebp
ret 22
