o_edges_list:   ; its too slow
; in  ->
;        eax - ptr to edges list in memory (there must be
;              declared enough size of mem)
;        ebx - ptr to faces
;        ecx - faces(triangles) count
;
; out ->
;        desired list, each edge in list as two dwords - indices
;          two position in vertices list, pointed by [points_r_ptr]
;        ecx - edges count

    push   ebp
    mov    ebp,esp
    sub    esp,50
    emms
    .new_ed        equ [ebp-4]
    .edges_ptr     equ [ebp-8]
    .triangles_ptr equ [ebp-12]
    .tri_count     equ [ebp-16]
    mov  .edges_ptr,eax
    mov  .triangles_ptr,ebx
    mov  .tri_count,ecx

    mov   eax,ecx
    imul  eax,[i27]
    invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
    mov   .new_ed,eax
    mov   edi,eax
    mov   esi,.triangles_ptr
    mov   ecx,.tri_count
  @@:
    movdqu   xmm0,[esi]     ; do temporary list
    movq     [edi],xmm0
    pshufd   xmm0,xmm0,10001001b
    movq     [edi+9],xmm0
    psrldq   xmm0,4
    movq     [edi+18],xmm0
    mov      byte[edi+8],0
    mov      byte[edi+17],0
    mov      byte[edi+26],0
    add      esi,12
    add      edi,27
    loop     @b

    mov      ecx,.tri_count
    lea      ecx,[ecx*3]
    mov      esi,.new_ed
;    int3
  .look_for:
    movq     mm0,[esi]
    movq     mm1,[esi]
    pshufw   mm1,mm1,01001110b
    lea       edi,[esi+9]
    push      ecx
  @@:
    movq      mm7,mm0
    movq      mm6,mm1
    pcmpeqd   mm7,[edi]
    pcmpeqd   mm6,[edi]
    pmovmskb  eax,mm7
    pmovmskb  ebx,mm6
    cmp       eax,0xff
    je        .found
    cmp       ebx,0xff
    je        .found
    add       edi,9
    loop       @b
    jmp        .non_red          ; unique edge
   .found:
    inc       byte[edi+8]
   .non_red:
    pop       ecx
    add       esi,9
    loop      .look_for
  ;  int3
    mov   edi,.edges_ptr   ; do final list
    mov   esi,.new_ed
    mov   ecx,.tri_count
    xor   ebx,ebx
    lea   ecx,[ecx*3]
  .check:
   cmp    byte[esi+8],1
   je     @f
   movq   mm0,[esi]
   movq   [edi],mm0
   inc    ebx
  @@:
   add    esi,9
   add    edi,8
   loop   .check

   mov     eax,.new_ed
   invoke  VirtualFree, eax , 0,  MEM_RELEASE
;   mov    eax,ebx
;   cdq
;   div    [i3]
   shl     ebx,1
   mov     ecx,ebx
   mov    esp,ebp
   pop    ebp
ret


go_init_ed_th:   ;
if 1    ;  roll off threads to easier debugging
    invoke CreateThread,NULL,NULL,search_ed_th0,\
           NULL,NORMAL_PRIORITY_CLASS,\
           [ThreadID0]
    mov    [hthread0],eax
    invoke SetThreadPriority,hthread0,THREAD_PRIORITY_TIME_CRITICAL

    invoke CreateThread,NULL,NULL,search_ed_th1,\
           NULL,NORMAL_PRIORITY_CLASS,\
           [ThreadID1]
    mov    [hthread1],eax
    invoke SetThreadPriority,hthread1,THREAD_PRIORITY_TIME_CRITICAL

 ;   invoke CreateThread,NULL,NULL, search_ed_th2,\
 ;          NULL,NORMAL_PRIORITY_CLASS,\
 ;          [ThreadID2]
 ;   mov    [hthread2],eax
 ;   invoke SetThreadPriority,hthread2,THREAD_PRIORITY_TIME_CRITICAL
 ;
 ;   invoke CreateThread,NULL,NULL,search_ed_th3,\
 ;          NULL,NORMAL_PRIORITY_CLASS,\
 ;          [ThreadID3]
 ;   mov    [hthread3],eax
 ;   invoke SetThreadPriority,hthread3,THREAD_PRIORITY_TIME_CRITICAL

    mov    ebx,2  ;4
    mov    esi,thread_array
    mov    edi,hthread0
  @@:
    invoke SetThreadAffinityMask,[edi],[esi]
    add    esi,4
    add    edi,4
    dec    ebx
    jnz    @b

  ;  invoke SetThreadAffinityMask, ;[hthread1],2
  ;  invoke SetThreadAffinityMask, ;[hthread2],3
  ;  invoke SetThreadAffinityMask, ;[hthread3],4

    invoke ResumeThread,[hthread0]
    invoke ResumeThread,[hthread1]
;    invoke ResumeThread,[hthread2]
;    invoke ResumeThread,[hthread3]

    invoke WaitForMultipleObjectsEx,2,hthread0,1,-1,0
    invoke CloseHandle,[hthread0]
    invoke CloseHandle,[hthread1]
;    invoke CloseHandle,hthread2
;    invoke CloseHandle,hthread3
end if

 ;   call   search_ed_th0
 ;   call   search_ed_th1
 ;   call   search_ed_th2
 ;   call   search_ed_th3



ret

search_ed_th0:
  xor    eax,eax
  call   search_ed_th
  invoke SendMessage,hwnd ,WM_FINISH,0,0
  invoke ExitThread,0
ret

search_ed_th1:
  mov    eax,1
  call   search_ed_th
  invoke SendMessage,hwnd ,WM_FINISH,0,0
  invoke ExitThread,1
ret

;search_ed_th2:
;  mov    eax,2
;  call   search_ed_th
;  invoke SendMessage,hwnd ,WM_FINISH,0,0
;  invoke ExitThread,2
;ret

;search_ed_th3:
;  mov    eax,3               ;hwnd
;  call   search_ed_th
;  invoke SendMessage,hwnd ,WM_FINISH,0,0
;  invoke ExitThread,3
;ret



search_ed_th:      ; for big ojects with many edges
;in : eax - thread no
;     esi - ptr to edges to compare
;     ecx - edges count
;     ebx - ptr to indicator - its a byte structure that shows
;           if thread found edge in list
;     xmm7  - current edge
       push  ebp
       mov   ebp,esp
       sub   esp,70
       and   ebp,-16
       emms
   .th_no         equ [ebp-4]
   .indicator_ptr equ [ebp-8]
   .cur_ed        equ [ebp-32]

   ; parameters via globals coz some cpu registers are cleared after
   ; divide to multithread

     movaps xmm7,[edges_th_xmm7]
     mov    esi,[edges_th_esi]
     mov    ebx,edges_th_ebx
     mov    ecx,[edges_th_ecx]



       mov      .indicator_ptr,ebx
       movdqa   .cur_ed,xmm7
       mov      .th_no,eax
       mov      edi,ecx
       shr      ecx,1
       imul     eax,ecx
       and      edi,01b
       shl      eax,3   ; 8 bytes per edge
       add      esi,eax
       cmp      .th_no,dword 3
       jne      @f
       add      ecx,edi
    @@:
    .search_edge:
     cmp      ecx,30
     jle      .search_one
     movaps   xmm7,.cur_ed
     movq     mm7,.cur_ed
     pshufd   xmm7,xmm7,00000000b ;search for only one vertex
                                  ; broadcasted one index
     pshufw   mm7,mm7,01000100b
   .search_simd:
     cmp      ecx,30
     jle      .search_one
     pxor     mm0,mm0
     mov      edx,esi
     test     edx,1000b
     je       @f
     movq     mm0,[edx]
     add      edx,8
   @@:
     movaps     xmm1,[edx]
     movaps     xmm2,[edx+16]
     movaps     xmm3,[edx+32]
     movaps     xmm4,[edx+48]
     movaps     xmm5,[edx+64]
     movaps     xmm6,[edx+80]
     movaps     xmm0,[edx+96]
     movq       mm1,[edx+112]
     movq       mm2,[edx+120]
     movq       mm3,[edx+128]
     movq       mm4,[edx+136]
     movq       mm5,[edx+144]
     movq       mm6,[edx+152]


     pcmpeqd    xmm1,xmm7 ;.one_i
     pcmpeqd    xmm2,xmm7 ;.one_i
     pcmpeqd    xmm3,xmm7 ;.one_i
     pcmpeqd    xmm4,xmm7 ;.one_i
     pcmpeqd    xmm5,xmm7 ;.one_i
     pcmpeqd    xmm6,xmm7 ;.one_i
     pcmpeqd    xmm0,xmm7 ;.one_i
     pcmpeqd    mm0,mm7
     pcmpeqd    mm1,mm7
     pcmpeqd    mm2,mm7
     pcmpeqd    mm3,mm7
     pcmpeqd    mm4,mm7
     pcmpeqd    mm5,mm7
     pcmpeqd    mm6,mm7

     por        xmm1,xmm2
     por        xmm3,xmm4
     por        xmm5,xmm6
     por        xmm1,xmm0
     por        xmm3,xmm5
     por        xmm1,xmm3

     por        mm0,mm1
     por        mm2,mm3
     por        mm4,mm5
     por        mm0,mm6

     por        mm2,mm4
     por        mm0,mm2

     packssdw   mm0,mm0
     movd       edx,mm0
     pmovmskb   eax,xmm1
     or         edx,eax
     jnz        .search_one    ; check if its really edge
                       ;ebx    ; not simple vertex
     cmp        [edges_th_ebx], dword 0 ; check if any thread find edge
     jne        .found
     add        esi,160
     sub        ecx,20
     jnc        .search_simd
     jmp        .nf

  .search_one:
     mov      edi,20
   @@:
     movq     xmm1,[esi]
     movdqa   xmm0,.cur_ed
     pshufd   xmm1,xmm1,00010100b  ; now search for 2 vertices ->
     pshufd   xmm0,xmm0,01000100b  ; -> one edge
     pcmpeqd  xmm1,xmm0

     pmovmskb eax,xmm1
     cmp      al,0xff
     je       .found      ; found - edge exist in list,
     shr      eax,8    ; so skip
     cmp      al,0xff
     je       .found
     add      esi,8
     sub      ecx,1
     jz       @f
     sub      edi,1
     jnz      @b
     or       ecx,ecx
     jnz      .search_edge
   @@:
   .nf:
   .break:
     ;   edge not found in list
     mov  ebx,.indicator_ptr
     add  ebx,.th_no
     xor  eax,eax
     lock xchg  [ebx],al ;byte 0
     add  esp,70
     pop  ebp
     ret
     ;   edge found
   .found:
     mov  ebx,.indicator_ptr
     add  ebx,.th_no
     mov  eax,1
     lock xchg [ebx],al ; byte 1
     add  esp,70
     pop  ebp
ret



do_edges_list:
; in  ->
;        eax - ptr to edges list in memory (there must be
;              declared enough size of mem)
;        ebx - ptr to faces
;        ecx - faces(triangles) count
;
; out ->
;        desired list, each edge in list as two words - indices
;          two position in vertices list, pointed by [points_r_ptr]
;        ecx - edges count

     push  ebp
     mov   ebp,esp
     sub   esp,70
     and   ebp,0xfffffff0
     emms
     .eedges_ptr     equ dword[ebp-4]
     .ttriangles_ptr equ [ebp-8]
     .ttri_count     equ dword[ebp-12]
     .eedges_cnt     equ dword[ebp-16]
     .eedge_fix      equ dword[ebp-36]
     .ccur_edge      equ [ebp-32]
     .oone_i         equ [ebp-48]
     .eedges_ind     equ [ebp-52]  ; thread edges indicator

     mov  .eedges_ptr,eax
     mov  .ttriangles_ptr,ebx
     mov  .ttri_count,ecx

     mov     .eedges_cnt,1
     movq    xmm0,[ebx]
     movq    [eax],xmm0
   .next_tri:
     mov     .eedge_fix,0
    ; load edge from triangles list
     movdqu   xmm0,[ebx]
     movdqa  .ccur_edge,xmm0
   .seek:
     mov      ecx,.eedges_cnt
     mov      esi,.eedges_ptr

   .search_edge:   ; does edge exist in list yet ?

     cmp      ecx,30
     jle      .search_one

     cmp      ecx,100000  ; for large objects
  ;   jmp      @f
     jle      @f
;in : eax  - thread no
;     esi  - ptr to edges to compare
;     ecx  - edges count
;     ebx  - ptr to indicator - its a byte structure that shows
;            if any thread found edge in list
;     xmm7 - current edge
  ;   lea    ebx,.edges_ind
  ;   mov    dword[ebx],  0
     mov    [edges_th_ebx],0
     movaps xmm7,.ccur_edge

     movaps [edges_th_xmm7],xmm7
     mov    [edges_th_esi],esi

     mov    [edges_th_ecx],ecx
     push  ebx
     call   go_init_ed_th
     pop   ebx

     mov    eax,[edges_th_ebx]
     cmp    [edges_th_ebx],dword 0 ;.edges_ind,dword 0

     ; if indictator <> 0 - edges found

     jne    .ef
     jmp    .store
   @@:
     movq     xmm7,.ccur_edge
     pshufd   xmm7,xmm7,00000000b ;search for only one vertex
  ;   movdqa .one_i,xmm7     ; broadcasted one index
     movq     mm7,.ccur_edge
     pshufw   mm7,mm7,01000100b

   .search_simd:
     cmp      ecx,30
     jle      .search_one
     pxor     mm0,mm0
     mov      edx,esi
     test     edx,1000b
     je       @f
     movq     mm0,[edx]
     add      edx,8
   @@:
     movaps     xmm1,[edx]
     movaps     xmm2,[edx+16]
     movaps     xmm3,[edx+32]
     movaps     xmm4,[edx+48]
     movaps     xmm5,[edx+64]
     movaps     xmm6,[edx+80]
     movaps     xmm0,[edx+96]
     movq       mm1,[edx+112]
     movq       mm2,[edx+120]
     movq       mm3,[edx+128]
     movq       mm4,[edx+136]
     movq       mm5,[edx+144]
     movq       mm6,[edx+152]

     pcmpeqd    xmm1,xmm7 ;.one_i
     pcmpeqd    xmm2,xmm7 ;.one_i
     pcmpeqd    xmm3,xmm7 ;.one_i
     pcmpeqd    xmm4,xmm7 ;.one_i
     pcmpeqd    xmm5,xmm7 ;.one_i
     pcmpeqd    xmm6,xmm7 ;.one_i
     pcmpeqd    xmm0,xmm7 ;.one_i
     pcmpeqd    mm0,mm7
     pcmpeqd    mm1,mm7
     pcmpeqd    mm2,mm7
     pcmpeqd    mm3,mm7
     pcmpeqd    mm4,mm7
     pcmpeqd    mm5,mm7
     pcmpeqd    mm6,mm7

     por        xmm1,xmm2
     por        xmm3,xmm4
     por        xmm5,xmm6
     por        xmm1,xmm0
     por        xmm3,xmm5
     por        xmm1,xmm3

     por        mm0,mm1
     por        mm2,mm3
     por        mm4,mm5
     por        mm0,mm6

     por        mm2,mm4
     por        mm0,mm2

     packssdw   mm0,mm0
     movd       edx,mm0
     pmovmskb   eax,xmm1
     or         edx,eax
     jnz        .search_one
     add        esi,160
     sub        ecx,20
     jnc        .search_simd
     jmp        .store

    .search_one:
     mov      edi,20
   @@:
     movq     xmm1,[esi]
     movdqa   xmm0,.ccur_edge
     pshufd   xmm1,xmm1,00010100b  ; now search for 2 vertices ->
     pshufd   xmm0,xmm0,01000100b  ; -> one edge
     pcmpeqd  xmm1,xmm0

     pmovmskb eax,xmm1
     cmp      al,0xff
     je       .ef      ; found - edge exist in list,
     shr      eax,8    ; so skip
     cmp      al,0xff
     je       .ef
     add      esi,8
     sub      ecx,1
     jz       @f
     sub      edi,1
     jnz      @b
     or       ecx,ecx
     jnz      .search_edge
   @@:
   .store:
     movdqa xmm0,.ccur_edge
     mov    esi,.eedges_cnt
     shl    esi,3
     add    esi,[edges_ptr]
     movq   [esi],xmm0

     add    .eedges_cnt,1

    .ef:    ; edge found
     add    .eedge_fix,1
     cmp    .eedge_fix,1
     jz     .ed1
     cmp    .eedge_fix,2
     jz     .ed2
     add    ebx,12
     jmp  .next_tri

   .ed1:
   ; load next edge of the same triangle
     movdqu  xmm0,[ebx]
     pshufd  xmm0,xmm0,00001001b
     movdqa  .ccur_edge,xmm0
     jmp     .seek

   .ed2:
   ; ....and last
     movdqu  xmm0,[ebx]
     pshufd  xmm0,xmm0,01010010b
     movdqa  .ccur_edge,xmm0
     mov     eax,.ttri_count
     sub     .ttri_count,1
     jnz     .seek

     mov     ecx,.eedges_cnt

     add     esp,70
     pop     ebp
ret


remove_redundant_vert:    ; remove redundand vertices
; in:
;     registers:
;        eax - approximation tolerancy (as dword float)
;     globals:
;        points_r_ptr, triangles_ptr, points_normals_ptr
;        points_count_var, triangles_count_var
; out:
;     recomputed vertices (points) and faces (triangles) list
   push ebp
   mov  ebp,esp
   sub  esp,256
   and  ebp,-16

   .new_vertices_ptr     equ dword[ebp-4] ; ptr to new vertices (each have its old index)
   .old_vertices_ptr     equ dword[ebp-8]
   .cnt_new_vert         equ dword[ebp-12]
   .cnt_old_vert         equ dword[ebp-16]
   .red_table_ind        equ dword[ebp-20]
   .cur_new_vertices_ptr equ dword[ebp-24] ;ptr of indexes of reedundant vertices
   .cnt_vert             equ dword[ebp-28]
   .temp_tri_ptr         equ dword[ebp-32]  ; tri list with one byte pro index
                                            ; for mark purposes
   .points_count_var     equ dword[ebp-36]
   .triangles_count_var  equ dword[ebp-40]
   .points_r_ptr         equ dword[ebp-44]
   .triangles_ptr        equ dword[ebp-48]
   .merge_mark           equ dword[ebp-64]
   .aprox_vert           equ [ebp-80]
   .aprox_norm           equ [ebp-96]
   .cn                   equ [ebp-112]
   .cn_ptr               equ dword[ebp-116]

    ; set approximation tolerancy
   movd    xmm7,eax
   shufps  xmm7,xmm7,0
   movaps   .aprox_vert,xmm7

   mov     .merge_mark,0
   cmp     [nr_care_flag],0 ; care about normal ?
   je      @f
   mov     ebx,0.001
   movd    xmm5,ebx
   shufps  xmm5,xmm5,0
   movaps  .aprox_norm,xmm5
   mov     .merge_mark,-1
 @@:
   push  [points_count_var]     ; init some local data
   pop   .points_count_var
   push  [triangles_count_var]
   pop   .triangles_count_var
   push  [points_r_ptr]
   pop   .points_r_ptr
   push  [triangles_ptr]
   pop   .triangles_ptr
if 0
  ; Go across the vertices list and find close vertices
  ; according to aproximation tolerancy value.
  ; For all found 'near' enough vertices, swap theys index in
  ; triangles list to vertex you actually compare.(You may also
  ; calculate theys mid value and insert in vertices list).
  ; Finally remove unused vertices. Make routintes ready to
  ; add merging triangle option.

  ; Maybye instead rewriting all proc, wriite an remove unused
  ; triangles rout... Triangles with redundant indexes

  mov    esi,[points_r_ptr]
  xor    ecx,ecx

  movups   xmm0,[esi]
  andps    xmm0,[zero_hgst_dd]
  movaps   xmm1,xmm0
  subps    xmm1,xmm7
  addps    xmm0,xmm7

  .reep:
  movups   xmm2,[esi]
  movups   xmm3,[esi]
  cmppslt  xmm2,xmm0
  cmppsnlt xmm3,xmm1
  xorps    xmm3,xmm2


  movaps   xmm1,[esi]
  movaps   xmm1,xmm0
  subps    xmm0,xmm7
  subps    xmm1,xmm7

end if
   ; alloc mem for new lists
   mov     eax,.triangles_count_var
   mul     [i15]
   add     eax,65536
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
 ;  int3
 @@:
   mov    .temp_tri_ptr,eax

   mov     eax,.points_count_var
   shl     eax,4
   add     eax,65536
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  ; int3
 @@:
   mov    .new_vertices_ptr,eax

   mov     eax,.points_count_var
   shl     eax,4
   add     eax,65536
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
 ;  int3
 @@:
   mov    .old_vertices_ptr,eax

   mov   esi,.points_r_ptr
   mov   edi,.old_vertices_ptr
   mov   ecx,.points_count_var
 @@:
   movups xmm0,[esi]
   movups [edi],xmm0
   mov    dword[edi+12],0x0 ; index and mark stamp
   add    esi,12
   add    edi,16
   sub    ecx,1
   jnz    @b

   mov      ebx,.old_vertices_ptr  ;[points_r_ptr]
   xor      ecx,ecx
   push     .new_vertices_ptr
   pop      .cur_new_vertices_ptr
   push     [points_normals_ptr]
   pop      .cn_ptr

 .next_vert:
   push     ecx
   mov      .cnt_old_vert,ecx
   mov      ecx,.cn_ptr
   movups   xmm7,[ecx]
   movaps   .cn,xmm7   ; cur normal
   movaps   xmm0,[ebx]

   cmp      dword[ebx+12],-1 ; mark
   je       .non_vertex

   mov      edx,.new_vertices_ptr
   mov      edi,[points_normals_ptr]
   xor      ecx,ecx
 .look_for_red:
   push     ecx
   cmp      dword[edx+12],-1
   je       .red_not_found  ; [edx+12] marked if redundant
   movaps   xmm1,xmm0
   movaps   xmm6,xmm0
   subps    xmm1,.aprox_vert
   addps    xmm6,.aprox_vert
   movups   xmm2,[edx]
   cmpltps  xmm1,xmm2
   cmpltps  xmm6,xmm2
   xorps    xmm1,xmm6

   movmskps eax,xmm1
   and      eax,0111b
   cmp      eax,0111b
   jne      .red_not_found  ; redundant vetexr found ->
                            ; -> ecx - its index
   cmp      .merge_mark,0
   je       @f               ; merge triangles cause
   movaps   xmm1,.cn         ; according to normal vect
   movaps   xmm6,.cn
   subps    xmm1,.aprox_norm
   addps    xmm6,.aprox_norm   ; check normal vect
   movups   xmm2,[edi]
   cmpltps  xmm1,xmm2
   cmpltps  xmm6,xmm2
   xorps    xmm1,xmm6
   movmskps eax,xmm1
   and      eax,0111b
   cmp      eax,0111b
   jne      .red_not_found
  @@:
   mov     dword[edx+12],-1   ; mark red
  ; renew triangles list
   mov     esi,.triangles_ptr
   mov     eax,ecx
   mov     ecx,.triangles_count_var
   lea     ecx,[ecx*3]
 .next:
   cmp     dword[esi],eax
   jne     @f
   push    .cnt_old_vert
   pop     dword[esi]
  @@:
   add     esi,4
   sub     ecx,1
   jnz     .next

 .red_not_found:
   pop     ecx
   add     ecx,1
   add     edx,16 ;  ;12
   add     edi,12
   cmp     ecx,.points_count_var
   jne     .look_for_red       ; look for redundant

   mov     eax,.cur_new_vertices_ptr
   movups  [eax],xmm0
   push    .cnt_old_vert
   pop     dword[eax+12]
   add     .cur_new_vertices_ptr,16
 .non_vertex:
   add     ebx,16
   add     .cn_ptr,12
   pop     ecx
   add     ecx,1
   cmp     ecx,.points_count_var
   jne     .next_vert
; w liscie new_vert sa nowe vertexy i ich stary indeks
; lista triang tez wymaga poprawienia na nowe indeksy

; in the list pointed by .new_vertices_ptr are new
; vertices and its old index, list pointed by triangles_ptr need
; renew too, instead old, it will be new indexes

  mov    ecx,.triangles_count_var
  lea    ecx,[ecx*3]
  mov    esi,.triangles_ptr
  mov    edi,.temp_tri_ptr
 @@:
  push   dword[esi]
  pop    dword[edi]
  mov    byte[edi+4],0
  add    esi,4
  add    edi,5
  sub    ecx,1
  jnz    @b

  mov    esi,.new_vertices_ptr
  mov    .cnt_vert,0
 .next_new_vert:
  mov    eax,dword[esi+12]
  cmp    eax,-1  ; check if redundant
  je     .skip_vrt
  xor    ecx,ecx
  mov    edx,.temp_tri_ptr
  mov    ebx,.triangles_count_var
  lea    ebx,[ebx*3]
 .next_index:
  cmp    [edx],eax
  jne    @f
  cmp    byte[edx+4],0  ; was the index previously changed ?
  jne    @f
  push   .cnt_vert
  pop    dword[edx]
  mov    byte[edx+4],0xff
 @@:
  add    edx,5
  add    ecx,1
  cmp    ecx,ebx
  jne    .next_index
  add    .cnt_vert,1
 .skip_vrt:
  add    esi,16
  cmp    esi,.cur_new_vertices_ptr
  jle    .next_new_vert

  mov      esi,.temp_tri_ptr   ; save desired data in 'global' list
  mov      edi,.triangles_ptr
  mov      ecx,.triangles_count_var
  xor      ebx,ebx

 .check_dead_tri:
  movdqu   xmm0,[esi]
  movdqa   xmm1,xmm0
  movdqa   xmm2,xmm0
  psrldq   xmm1,1
  psrldq   xmm2,2
  pand     xmm0,[mask1]
  pand     xmm1,[mask2]
  pand     xmm2,[mask3]
  por      xmm0,xmm1
  por      xmm0,xmm2

  movdqa   xmm1,xmm0
  pshufd   xmm0,xmm0,11010010b
  pcmpeqd  xmm0,xmm1
  pmovmskb eax,xmm0
  and      eax,0x0fff
  or       eax,eax
  jnz      .f

if 0
  cmp      ebx,2
  jle      .do_add
  push     edi
  xor      edx,edx
 @@:
  cmp      edx,ebx
  je       .ok        ; check for redundant
                      ; triangle (not needed!!?)
  movdqa   xmm7,xmm1
  movdqa   xmm5,xmm1
  movdqu   xmm6,[edi-12]
  movdqa   xmm4,xmm1
  movdqa   xmm3,xmm1
  pshufd   xmm5,xmm5,11010010b
  pshufd   xmm4,xmm4,11001001b
  pshufd   xmm3,xmm3,11011000b

  pcmpeqd  xmm7,xmm6
  pcmpeqd  xmm5,xmm6
  pcmpeqd  xmm4,xmm6
  pcmpeqd  xmm3,xmm6
  por      xmm7,xmm5
  por      xmm4,xmm3
  por      xmm7,xmm4
  pmovmskb eax,xmm7
  and      eax,0x0fff
  cmp      eax,0x0fff
  jz       .ff
  sub      edi,12
  add      edx,1
  jmp      @b

 .ok:
  pop      edi

  jmp      .do_add

 .ff:
  pop      edi
  jmp      .f
end if

 .do_add:
  add      ebx,1
  movdqu   [edi],xmm1
  add      edi,12
 .f:
  add      esi,15
  sub      ecx,1
  jnz     .check_dead_tri

  mov      .triangles_count_var,ebx
;  renew list pointed by [points_r_ptr]
  mov      esi,.new_vertices_ptr
  mov      edi,.points_r_ptr
  xor      ecx,ecx
  xor      edx,edx
 .again:
  movups   xmm0,[esi]
  cmp      dword[esi+12],-1
  je       .skip
  movlps   [edi],xmm0
  movhlps  xmm0,xmm0
  movss    [edi+8],xmm0
  add      edx,1
  add      edi,12
 .skip:
  add      esi,16
  add      ecx,1
  cmp      ecx,.points_count_var
  jnz      .again
  mov      [points_count_var],edx

  push     .triangles_count_var
  pop      [triangles_count_var]
  invoke   VirtualFree ,.new_vertices_ptr ,0 , MEM_RELEASE
  invoke   VirtualFree ,.old_vertices_ptr ,0 , MEM_RELEASE
  invoke   VirtualFree ,.temp_tri_ptr ,0 , MEM_RELEASE
  add      esp,256
  pop      ebp
ret

set_triangulize_rect:
; in eax - coords y shl 16 + x
        movd      xmm0,eax
        pxor      xmm1,xmm1
        punpcklwd xmm0,xmm1
        cvtdq2ps  xmm0,xmm0
        cmp      [edit_tri_area],2; cx,65535
        jnz    @f
        movlps    qword[tri_area_x1],xmm0
        jmp       .end
     @@:
        cmp     [edit_tri_area],1  ; cx,65534
        jnz    .end
        movlps    qword[tri_area_x2],xmm0
  .end:
ret


draw_triangulize_rect:
    movups    xmm0,dqword[tri_area_x1]
    cvtps2dq  xmm0,xmm0
    shufps    xmm0,xmm0,11011000b
    packssdw  xmm0,xmm0
    movd      eax,xmm0
    psrldq    xmm0,4
    movd      ebx,xmm0

    movd     mm1,[screen_ptr]
   ;  movd     mm0,[Zbuffer_ptr]
    movzx    ecx,[xres_var]
    movd     mm2,ecx
    mov      ecx,0x0000ff00
    movd     mm3,ecx

    call      write_frame
    mov       ecx,65533         ; other const mark
    movlps    xmm0,qword[tri_area_x1]
    movzx     edx,[xres_var]
    sub       edx,4
    movzx     esi,[yres_var]
    sub       esi,4
    call      bar_edge

    mov       ecx,65532
    movlps    xmm0,qword[tri_area_x2]
    movzx     edx,[xres_var]
    sub       edx,4
    movzx     esi,[yres_var]
    sub       esi,4
    call      bar_edge
ret

calc_shadow:  ; calc shadow 4X4 matrix
 ; in esi -> light vector - ptr to 3 dwords float
 ;    ebx -> ptr to 4x4 shadow matrix 16 dwords, 64 bytes
 movups xmm1,[plane_equation]
 movups xmm0,[esi]
 andps  xmm0,[zero_hgst_dd]
 orps   xmm0,[one_hgst_dd]
 movaps xmm2,xmm0  ; xmm2 light vector
 mulps  xmm0,xmm1
 haddps xmm0,xmm0
 haddps xmm0,xmm0
 movaps xmm4,xmm0  ; xmm4 - dot product

 ; do 4x4 shadow matrix
 movss  xmm3,[plane_equation]
 shufps xmm3,xmm3,0
 mulps  xmm3,xmm2
 movups [ebx],xmm3
 addss  xmm3,xmm4
 movss  [ebx],xmm3

 movss  xmm3,[plane_equation+4]
 shufps xmm3,xmm3,0
 mulps  xmm3,xmm2
 movups [ebx+16],xmm3
 shufps xmm3,xmm3,11100001b
 addss  xmm3,xmm4
 movss  [ebx+20],xmm3

 movss  xmm3,[plane_equation+8]
 shufps xmm3,xmm3,0
 mulps  xmm3,xmm2
 movups [ebx+32],xmm3
 shufps xmm3,xmm3,11000110b
 addss  xmm3,xmm4
 movss  [ebx+40],xmm3

 movss  xmm3,[plane_equation+12]
 shufps xmm3,xmm3,0
 mulps  xmm3,xmm2
 movups [ebx+48],xmm3
 shufps xmm3,xmm3,00100111b
 addss  xmm3,xmm4
 movss  [ebx+60],xmm3      ; finaly matrix done
ret


if 0
calc_p_light_coords:
; in   - none
; out  - xmm1 -> light position
; uses - edx, xmm0, xmm1, xmm3
    movups   xmm0,[point_light]   ;     calculate light coords.
    movzx    edx,[xres_var]
    cvtsi2ss xmm1,edx
    shufps   xmm1,xmm1,11000000b
    mulps    xmm1,xmm0

    movdqu   xmm3,[xxadd]
    cvtdq2ps xmm3,xmm3
    subps    xmm1,xmm3
  ;  addps    xmm1,xmm1      ; xmm1 - first point light position
    movups   [point_light_coords],xmm1
ret
end if

xy_in_rect:
 ; in:
 ; eax - current y shl 16 + x
 ; ecx - y1 shl 16 + x1
 ; edx - y2 shl 16 + x2
 ;out:
 ; ebx = 0 no, ebx = 1 yes

  movd  xmm0,eax
  movd  xmm1,ecx
  movd  xmm2,edx
  pcmpgtw  xmm1,xmm0
  pcmpgtw  xmm2,xmm0
  pxor     xmm2,xmm1
  pmovmskb ebx,xmm2
  cmp      ebx,1111b
  jne     .end_no
  mov   ebx,1
  ret
 .end_no:
  xor  ebx,ebx
ret

move_texture:
 ;  eax - move x
 ;  ebx - move y
    push ebp

    .x_tex   equ  [ebp-6]
    .y_tex   equ  [ebp-4]
    mov   ebp,esp
    sub   esp,64
    mov   .x_tex,ax
    mov   .y_tex,bx
    cmp   ebx,0
    je    .xx
    jl    .ysub      ;jl

    mov   eax,ebx
    mov   edx,TEX_X
    mul   edx
    mov   ebx,eax
    shl   ebx,2
    lea   esi,[texmap+ebx]
    lea   edi,[texmap]
  ;  cld
    mov   ecx,TEX_X*TEX_Y
    sub   ecx,eax
  ;  rep   movsd
  @@:
    push  dword[esi]
    pop   dword[edi]
    add   esi,4
    add   edi,4
    sub   ecx,1
    jnz   @b
    jmp   .xx
 .ysub:
    mov   esi,texmap
    add   esi,TEX_X*TEX_Y*4
    mov   edi,esi
    neg   ebx
    mov   eax,TEX_X
    mul   ebx
    lea   ecx,[eax*4]
    sub   esi,ecx
  ;  std
    mov   ecx,TEX_X*TEX_Y
    sub   ecx,eax
  @@:
    push  dword[esi]
    pop   dword[edi]
    sub   esi,4
    sub   edi,4
    sub   ecx,1
    jnz   @b
 ;   rep   movsd
  .xx:
    cmp   word .x_tex,0
    je    .end
    jl    .xadd
    movzx eax,word .x_tex
 ;   neg   eax
    lea   edx,[eax*4]
  ;  cld
    xor   ebx,ebx
    lea   esi,[texmap+edx]
    lea   edi,[texmap]
  .next_xsub_l:
    mov   ecx,TEX_X
    sub   ecx,eax
  @@:
    push  dword[esi]
    pop   dword[edi]
    add   edi,4
    add   esi,4
    sub   ecx,1
    jnz   @b
   ; rep   movsd

    add   esi,edx
    add   edi,edx
    add   ebx,1
    cmp   ebx,TEX_Y
    jne   .next_xsub_l
    jmp   .end

   .xadd:

    movsx eax, word .x_tex
    neg   eax

    lea   edx,[eax*4]
  ;  std
    xor   ebx,ebx
    lea   esi,[texmap+TEX_X*TEX_Y*4]
    mov   edi,esi
    sub   esi,edx
  @@:
 .nextxadd_l:
    mov   ecx,TEX_X
    sub   ecx,eax
  @@:
    push  dword[esi]
    pop   dword[edi]
    sub   esi,4
    sub   edi,4
    sub   ecx,1
    jnz   @b
  ;  rep   movsd
    sub   esi,edx
    sub   edi,edx
    add   ebx,1
    cmp   ebx,TEX_Y
    jne   .nextxadd_l;@b

  .end:
   mov    esp,ebp
   pop   ebp
ret

apply_displacement_from_tex:
.vert1_ptr equ dword[ebp-4]
.vert2_ptr equ dword[ebp-8]
.vert3_ptr equ dword[ebp-12]
        push  ebp
        mov   ebp,esp
        sub   esp,128

        xor   ecx,ecx
      .next_vert:
        push   ecx                      ; ecx - vertex counter
        mov    ebx,ecx
        imul   ebx,[i12]
        mov    edi,ebx
        add    edi,[points_normals_rotated_ptr]
        add    ebx,[points_r_ptr]
        movups xmm0,[ebx]
        mov    .vert1_ptr,ebx

        mov    esi,ecx
        mov    eax,ecx
        shl    eax,2
        add    eax,[tex_points_ptr]
        mov    ecx,eax
        movzx  eax,word[eax+2] ; tex y
        mov    edx,TEX_X
        mul    edx
        movzx  ecx,word[ecx]   ; tex x
        add    ecx,eax
        shl    ecx,2
        add    ecx,texmap
        mov    eax,ecx
        mov    ecx,[ecx]
        and    ecx,0x00ffffff
        cmp    ecx,[displ_transparent_col]  ;0x00ffffff
        je     .no  ; no change if transparent - white color
        cmp    [td_wp_flag],0  ; only vertices with positive normal z
                               ; cooficient are computed or all vertices ?
        jz     .whole
        test   dword[edi+8],0x80000000   ; check sign of z coof
        jz     .no
      .whole:
        movzx  ecx,byte[eax]   ; read R,G,B pixel
        movzx  ebx,byte[eax+1]
        add    ecx,ebx
        movzx  ebx,byte[eax+2]
        add    ecx,ebx



        mov    eax,esi
        imul   eax,[i12]
        add    eax,[points_normals_ptr]
        movups xmm7,[eax]
        cvtsi2ss xmm6,ecx
        cvtsi2ss xmm5,[displac_div]
        divss    xmm6,xmm5
        shufps  xmm6,xmm6,0
        mulps   xmm7,xmm6
        addps   xmm0,xmm7
        mov     ebx,.vert1_ptr
        movlps  [ebx],xmm0
        movhlps xmm0,xmm0
        movss   [ebx+8],xmm0
      .no:

        pop    ecx
        inc    ecx
        cmp    ecx,[points_count_var]
        jnz    .next_vert

        mov    esp,ebp
        pop    ebp

ret




load_tetrahedron:

    mov   esi,tetra_points_r
    mov   edi,[points_r_ptr]
    cld
    fninit
    mov   ecx,tetra_points_count*3 + 1
  @@:
    rep   movsd
;    fild  word[esi]
;    fstp  dword[edi]
;    add   esi,2
;    add   edi,4
;    loop  @b
;    movsd

    mov   esi,tetra_triangles
    mov   edi,[triangles_ptr]
    mov   ecx,tetra_triangles_count*12 + 2
  @@:
    movzx eax,word[esi]
    mov   [edi],eax
    add   esi,2
    add   edi,4
    loop  @b
   ; rep   movsw


    mov   ecx,tetra_triangles_count * 12 + 1
    mov   esi,tetra_tex_points
    mov   edi,[tex_points_ptr]
    rep   movsd

    mov  [triangles_count_var],tetra_triangles_count
    mov  [points_count_var],tetra_points_count
ret
blur_screen:

;blur n times  ; blur or fire
;in - ecx  times count
;.counter equ dword[esp-4]
.counter1 equ dword[esp-8]

         push       ebp
         mov        ebp,esp
         movaps     xmm5,[blur_sub]
     .again_blur:
         push       ecx
         mov        edi,[screen_ptr]
         movzx      ecx,[xres_var]  ;SIZE_X
         xor        eax,eax
         rep        stosd
;         add        edi,16
;         and        edi,-16
         movzx      ecx,[xres_var]  ;SIZE_X
         movzx      ebx,[yres_var]  ;SIZE_X
         sub        ebx,4
         imul       ecx,ebx
         shr        ecx,2
         movzx      ebx,[xres_var]  ;SIZE_X
  ;       mov        ecx,(SIZE_X*(SIZE_Y-4))*4/16
         mov        esi,edi
         mov        edx,ebx
         shl        edx,2
         sub        esi,edx
     .blr:
     @@:
         movaps     xmm0,[edi+ebx*4]
     ;    movaps     xmm1,[esi];[edi-ebx*4]
         movaps     xmm2,[edi-16]
     ;    movaps     xmm3,[edi+16]

         pavgb      xmm0,[esi]
         pavgb      xmm2,[edi+16]
         pavgb      xmm0,xmm2

         psubusb    xmm0,xmm5  ; importand if fire

         movaps     [edi],xmm0
         add        edi,16
         add        esi,16

         loop       .blr

         xor        eax,eax
         movzx      ecx,[xres_var] ;SIZE_X
         rep        stosd
         pop        ecx
         loop       .again_blur
         mov        esp,ebp
         pop        ebp
ret

normalize_object1:  ; procedure don't save registers !!
; in:   stack 1 - vertices count to normalise
;       stack 2 - pointer to vertices
; out:  xmm7 - broadcasted reciprocal of maxscale
;       xmm0 - center

        .points_count equ ebp+4
        .points_r     equ ebp+8

       mov   ebp,esp
       mov  ecx,[.points_count]
       sub  ecx,1
       mov  edi,[.points_r]

       movups  xmm0,[edi]
       movups  xmm2,[edi]
     @@:
       movups  xmm1,[edi+12]
       maxps   xmm0,xmm1
       minps   xmm2,xmm1
       add     edi,12
       sub     ecx,1
       jnz     @b
       movaps  xmm3,xmm0   ; scale
       subps   xmm0,xmm2
       divps   xmm0,[f2x4]
       subps   xmm3,xmm0   ; xmm3 - this we sub from all

       movaps  xmm4,xmm0
       movaps  xmm5,xmm0
       shufps  xmm4,xmm4,11100001b
       shufps  xmm5,xmm5,11000110b
       maxss   xmm4,xmm0
       maxss   xmm4,xmm5    ; xmm4 - max scale
       movss   [max_scale],xmm4
       shufps  xmm4,xmm4,0
       rcpps   xmm4,xmm4

       mov     ecx,[.points_count]
  ;     sub     ecx,1
       mov     edi,[.points_r]
     @@:
       movups  xmm0,[edi]
       subps   xmm0,xmm3    ; set 0,0,0 in center
       mulps   xmm0,xmm4    ; scale
       movhlps xmm1,xmm0
       movlps  [edi],xmm0
       movss   [edi+8],xmm1
       add     edi,12
       sub     ecx,1
       jnz     @b

       movaps  xmm7,xmm4
       movaps  xmm0,xmm3

       mov    esp,ebp

ret 8
if 0
generate_texture1:                  ; draw heart in texture buffer
       .x1       equ  ebp-4
       .y1       equ  ebp-8
       .x2       equ  ebp-12
       .y2       equ  ebp-16
       .x3       equ  ebp-20
       .y3       equ  ebp-24
       .hrt_scale  equ ebp-28

       push      ebp
       mov       ebp,esp
       sub       esp,128

       mov       esi,hrt_points
       mov       edi,hrt_[points_r_ptr]
       mov       ecx,hrt_points_count
       lea       ecx,[ecx*3]
       fninit
     @@:
       fild      word[esi]       ; convert from integer to float
       fstp      dword[edi]
       add       esi,2
       add       edi,4
       loop      @b

       pushad
       push   dword hrt_[points_r_ptr]
       push   dword hrt_points_count
       call   normalize_object1
       popad

     mov   eax,0x00ffffff         ; fill tex buffer
     mov   edi,texmap
     cld
     mov   ecx,TEXTURE_SIZE
     rep   stosd

     mov   dword[.hrt_scale],100.0
     push  [line_buffer_var]            ; draw in texmap buffer
     push  [screen_width_var]
     mov   [screen_width_var],TEX_X
     mov   [line_buffer_var],texmap
     xor   ecx,ecx
     fninit
  @@:
     push  ecx
     lea   ecx,[ecx*3]
     lea   esi,[hrt_triangles+ecx*2]

     movzx eax,word[esi]
     lea   eax,[eax*3]
     shl   eax,2
     fld   dword[eax+hrt_[points_r_ptr]]
     fmul  dword[.hrt_scale]
     fiadd      [tex_x_div2]
   ;  fadd  dword[.hrt_scale]
     fistp dword[.x1]

     fld   dword[eax+4+hrt_[points_r_ptr]]
     fmul  dword[.hrt_scale]
     fiadd      [tex_x_div2]
;     fadd  dword[.hrt_scale]
     fistp dword[.y1]

     movzx eax,word[esi+2]
     lea   eax,[eax*3]
     shl   eax,2
     fld   dword[eax+hrt_[points_r_ptr]]
     fmul  dword[.hrt_scale]
     fiadd      [tex_x_div2]
;     fadd  dword[.hrt_scale]
     fistp dword[.x2]

     fld   dword[eax+4+hrt_[points_r_ptr]]
     fmul  dword[.hrt_scale]
     fiadd      [tex_x_div2]
   ;  fadd  dword[.hrt_scale]
     fistp dword[.y2]


     movzx eax,word[esi+4]
     lea   eax,[eax*3]
     shl   eax,2
     fld   dword[eax+hrt_[points_r_ptr]]
     fmul  dword[.hrt_scale]
    ; fadd  dword[.hrt_scale]
     fiadd      [tex_x_div2]
     fistp dword[.x3]

     fld   dword[eax+4+hrt_[points_r_ptr]]
     fmul  dword[.hrt_scale]
     fiadd      [tex_x_div2]
;     fadd  dword[.hrt_scale]
     fistp dword[.y3]


     pushad
     mov   eax,[.x1]
     mov   ebx,[.y1]
     mov   ecx,[.x2]
     mov   edx,[.y2]
     and   eax,0x000001ff    ; truncate if exceedes texture area
     and   ebx,0x000001ff
     and   ecx,0x000001ff
     and   edx,0x000001ff
     call  linea
     popad

     pushad
     mov   eax,[.x1]
     mov   ebx,[.y1]
     mov   ecx,[.x3]
     mov   edx,[.y3]
     and   eax,0x000001ff
     and   ebx,0x000001ff
     and   ecx,0x000001ff
     and   edx,0x000001ff
     call  linea
     popad

     pushad
     mov   eax,[.x2]
     mov   ebx,[.y2]
     mov   ecx,[.x3]
     mov   edx,[.y3]
     and   eax,0x000001ff
     and   ebx,0x000001ff
     and   ecx,0x000001ff
     and   edx,0x000001ff
     call  linea
     popad

     pop   ecx
     inc   ecx
     cmp   ecx,hrt_triangles_count
     jne   @b


     pop   [screen_width_var]
     pop   [line_buffer_var]

     mov   esp,ebp
     pop   ebp
ret
end if
generate_texture1:  ; do blank texture uses for smooth objects edges
       mov  edi,texmap
       mov  eax,0xffffffff
       mov  ecx,TEX_X*TEX_Y
       cld
       rep  stosd
ret

generate_texture3:

       mov  edi,texmap
       xor  ecx,ecx
       cld
     .next:
       xor  ebx,ebx
     @@:
       mov  eax,ecx
       mov  edx,ebx
       xor  eax,edx
       mov  ah,al
       push ax
       shl  eax,8
       pop  ax
;       or   eax,0x00f00000
       ;mov  [edi],eax
       ;add  edi,4
       stosd
       inc  ebx
       cmp  ebx,TEX_X
       jne  @b
       inc  ecx
       cmp  ecx,TEX_Y
       jne  .next
ret

generate_texture2:
.const equ 32
        cld
        mov     edi,texmap
        xor     bx,bx
     .next_line:
        xor     dx,dx
     .next2stripes:
        mov     eax,-1
        mov     ecx,(TEX_X/.const)
        rep     stosd
        mov     eax,0x00ff0000
        mov     ecx,(TEX_X/.const)
     @@:
        stosd
        loop    @b
        inc     dx
        cmp     dx,.const/2
        jl      .next2stripes
        inc     bx
        cmp     bx,TEX_Y
        jl      .next_line
ret

calc_bumpmap_coords:      ; map texture, bump

      fninit
      fldpi
      fadd      st,st
      mov       esi,[points_r_ptr]
      mov       edi,[tex_points_ptr]
      mov       ecx,[points_count_var]
      inc       ecx

   .again:
      cmp       [map_flag],2
      jg        .spherical
       ; choose map planar or spherical
       ; map flag 1,2,3 - various planar mapping
      cmp      [map_flag],0
      jne      @f
      xor      eax,eax
      mov      ebx,4
      jmp      .do_planar
  @@:
      cmp      [map_flag],1
      jne      @f
      mov      eax,4
      mov      ebx,8
      jmp      .do_planar
  @@:
;      cmp      [map_flag],3
;      jne      @f
      mov      eax,8
      mov      ebx,4
   .do_planar:
   @@:
      fld       dword[esi+eax]
      fimul     [tex_x_div2]   ; planar map
      fiadd     [tex_x_div2]
      fistp     word[edi]

      fld       dword[esi+ebx]
      fimul     [tex_x_div2]
      fiadd     [tex_x_div2]
      fistp     word[edi+2]

      add      esi,12
      add      edi,4
      loop     .do_planar

      jmp       .end
;      cmp       [map_tex_flag],1
;      jne       .cylindric
   .spherical:
;
;      cmp      [map_flag],3
;      jne      @f
;      xor      eax,eax
;      mov      ebx,4
;      jmp      .do_sp
;  @@:
;      cmp      [map_flag],4
;      jne      @f
;      mov      eax,4
;      mov      ebx,8
;      jmp      .do_sp
;  @@:
;;      cmp      [map_flag],3
;;      jne      @f
;      mov      eax,8
;      mov      ebx,0
;      ; spherical mapping around y axle
;   .do_sp
   @@:
      fld       dword[esi]     ; x coord
      fld       dword[esi+8]   ; z coord
      fpatan                   ; arctg(st1/st)
;      fdiv      .Pi2
      fdiv      st0,st1
      fimul     [tex_x_div2]
      fiadd     [tex_x_div2]
      fistp     word[edi]      ; x

      fld       dword[esi+4]   ; y coord
      fld       dword[esi]     ; x
      fmul      st,st0
      fld       dword[esi+4]   ; y
      fmul      st,st0
      fld       dword[esi+8]   ; z
      fmul      st,st0
      faddp
      faddp
      fsqrt
      fpatan
      fldpi
      fdivp
      fimul    [tex_y_div2]
      fiadd    [tex_y_div2]
      fistp    word[edi+2]     ; y


      add      esi,12
      add      edi,4
      loop     @b
   .end:
      ffree    st0

ret


calc_bumpmap:            ; calculate random bumpmap
;--------------in edi _ pointer to TEX_X x TEX_Y bumpmap

         pushad

         mov     edi, bump_map
         mov     esi,texmap
         mov     ecx,TEXTURE_SIZE
         cmp     [bump_flag],0
         je      .random_bump_map
         ; else bumps according to texture
      @@:
         movzx   ax,byte[esi]
         movzx   bx,byte[esi+1]
         movzx   dx,byte[esi+2]
         add     ax,bx
         add     ax,dx
         cwde
         cdq
         div     [i3]
         stosb
         add     esi,4
         loop    @b
         jmp     .blur_map

  .random_bump_map:

  ;       RDTSC
  ;       mov    [rand_seed],ax
      @@:
         push    ecx
         xor     ecx,ecx
         mov     edx,255
         call    random
         stosb
         pop    ecx
         loop   @b

      .blur_map:

      ;   movzx  ecx,[bumps_deep_flag]
         mov    edi, bump_map
         mov    ecx,4
      .blur:
         xor    esi,esi
         mov    edx,TEXTURE_SIZE
         xor    eax,eax
         xor    ebx,ebx
      @@:
         mov    ebp,esi
         dec    ebp
         and    ebp,TEXTURE_SIZE
         mov    al,byte[ebp+edi]

         mov    ebp,esi
         inc    ebp
         and    ebp,TEXTURE_SIZE
         mov    bl,byte[ebp+edi]
         add    eax,ebx

         mov    ebp,esi
         sub    ebp,TEX_X
         and    ebp,TEXTURE_SIZE
         mov    bl,byte[ebp+edi]
         add    eax,ebx

         mov    ebp,esi
         add    ebp,TEX_X
         and    ebp,TEXTURE_SIZE
         mov    bl,byte[ebp+edi]
         add    eax,ebx

         shr    eax,2
         mov    byte[esi+edi],al

         inc    esi
         dec    edx
         jnz    @b

         loop   .blur
         popad
ret


make_random_lights:
  .temp1  equ ebp-4
  .temp2  equ ebp-8     ;  - light vector generate variables
  .temp3  equ ebp-12
  .col1   equ ebp-20
  .col2   equ ebp-28
  .col3   equ ebp-32
  .max equ 800
;        RDTSC
;        mov    [rand_seed],ax
        push    ebp
        mov     ebp,esp
        sub     esp,64
        mov     edi,lights
        fninit
        mov     dword[.temp2],.max
        mov     dword[.temp3],.max/2

    .again:
        xor     esi,esi
     @@:
        mov     edx,.max
        xor     ecx,ecx
        call    random
        sub     eax,.max/2
        mov     dword[.temp1],eax
        fild    dword[.temp1]
        fidiv   dword[.temp3]
        fstp    dword[edi+esi*4]
        inc     esi
        cmp     esi,2
        jne     @b

  .max1 equ 1000
        mov     dword[.temp2],.max1/2
        mov     edx,.max1
        xor     ecx,ecx
        call    random
        mov     dword[.temp1],eax
        fild    dword[.temp1]
        fchs
        fidiv   dword[.temp2]
        fstp    dword[edi+8]

        xor     esi,esi
     @@:
        mov     ecx,220            ; max colors and shine  , ecx = 200 - more bright shading
        mov     edx,255
        call    random
        movzx   ax,al
        mov     [edi+28+esi*2],ax
        inc     esi
        cmp     esi,4
        jne     @b

        xor     esi,esi
     @@:
        mov     ecx,100              ; orginal colors
        movzx   edx,word[edi+28+esi*2]
        call    random
        movzx   ax,al
        mov     [edi+12+esi*2],ax
        inc     esi
        cmp     esi,3
        jne     @b

        xor     esi,esi
     @@:
        mov     ecx,1               ; min cols
        movzx   edx,word[edi+12+esi*2]
        call    random
        movzx   ax,al
        mov     [edi+20+esi*2],ax
        inc     esi
        cmp     esi,3
        jne     @b

        add     edi,LIGHT_SIZE ;22
        cmp     edi,lightsend
        jne     .again


        mov       esi,lights
        mov       edi,lights_aligned



     .do_aligned: ; make aligned float lights used
                  ; in all Real Phong rendering models
        movups    xmm0,[esi]
        orps      xmm0,[z_minus_mask]
        movaps    xmm1,xmm0    ; normalize
        mulps     xmm1,xmm1
        andps     xmm1,[zero_hgst_dd]
        haddps    xmm1,xmm1
        haddps    xmm1,xmm1
        rsqrtps   xmm1,xmm1
        mulps     xmm0,xmm1


if 0
        mov       ecx,1
        mov       edx,255
        call      random
        sub       eax,128
        cvtsi2ss  xmm0,eax
        divss     xmm0,[f256d]
        mov       ecx,1
        mov       edx,255
        call      random
        sub       eax,128
        cvtsi2ss  xmm1,eax
        divss     xmm1,[f256d]
        mov       ecx,1
        mov       edx,255
        call      random
        sub       eax,128
        cvtsi2ss  xmm2,eax
        divss     xmm2,[f256d]

        shufps    xmm1,xmm1,11100001b
        por       xmm0,xmm1
        movlhps   xmm0,xmm2
        orps      xmm0,[z_minus_mask]
        movaps    xmm1,xmm0
        mulps     xmm1,xmm1

        andps     xmm1,[zero_hgst_dd]
        haddps    xmm1,xmm1
        haddps    xmm1,xmm1
        rsqrtps   xmm1,xmm1
        mulps     xmm0,xmm1
end if


        movq      xmm1,[esi+12]
        movq      xmm2,[esi+12+8]
        movq      xmm3,[esi+12+16]
     ;   psrlw     xmm1,2
        punpcklwd xmm1,[the_zero]
        punpcklwd xmm2,[the_zero]
        punpcklwd xmm3,[the_zero]
        psrld     xmm1,1
        psrld     xmm2,1
      ;  psrld     xmm3,1

        andps     xmm0,[zero_hgst_dd]
        cvtdq2ps  xmm1,xmm1
        cvtdq2ps  xmm2,xmm2
        cvtdq2ps  xmm3,xmm3
        andps     xmm1,[zero_hgst_dd]
        andps     xmm2,[zero_hgst_dd]
        andps     xmm3,[zero_hgst_dd]

        movaps    [edi],xmm0
        movaps    [edi+16],xmm1
        movaps    [edi+32],xmm2
        movaps    [edi+48],xmm3

        add       edi,64
        add       esi,LIGHT_SIZE
        cmp       esi,lightsend
        jne       .do_aligned


        mov     esp,ebp
        pop     ebp
ret

random:
;  in  - ecx - min
;        edx - max
;  out - eax - random number
         mov    bx,[rand_seed]
         add    bx,0x9248
         ror    bx,3
         mov    [rand_seed],bx

         mov    ax,dx
         sub    ax,cx
         mul    bx
         mov    ax,dx
         add    ax,cx
         cwde
ret

do_color_buffer:         ; do color buffer for Gouraud, flat shading
;env_map 512 x 512 x 3 bytes    ; many lights using
.temp  equ word   [ebp-2]
.nz    equ dword  [ebp-6]  ; dword
.ny    equ dword  [ebp-10]
.nx    equ dword  [ebp-14]
.col_r equ    [ebp-16]
.col_g equ    [ebp-17]
.col_b equ    [ebp-18]

         push     ebp
         mov      ebp,esp
         sub      esp,20
         mov      edi,color_map
         fninit

         mov      dx,- TEX_Y / 2 ;-256   ; dx - vertical coordinate = y
    .ie_ver:
         mov      cx,- TEX_X / 2 ;256   ; cx - horizontal coord = x
    .ie_hor:
         mov      .temp,cx
         fild     .temp
         fidiv    [tex_x_div2];[i256]st = Nx - vector normal x cooficient
         fst      .nx
         fmul     st,st0
         mov      .temp,dx
         fild     .temp
         fidiv    [tex_y_div2];[i256]st = Ny - vector normal y coeficient
         fst      .ny
         fmul     st,st0
         faddp
         fld1
         fchs
         faddp
         fabs
         fsqrt
         fchs
         fstp     .nz              ; st - Nz - vect normal z coeficient
         xor      ebx,ebx
         mov      dword .col_b, 0
     .light:
         push     edi   ;env_map
         lea      esi,[lights+ebx]
         lea      edi,.nx
         call     dot_product
         pop      edi
         fcom     dword[dot_min]
         fstsw    ax
         sahf
         ja       .env_ok1  ;compare with dot_max
         ffree    st

        jmp       .update_counters
      .env_ok1:
         fcom    dword[dot_max]
         fstsw   ax
         sahf
         jb      .env_ok2     ; calc col
         ffree   st
         jmp     .update_counters
      .env_ok2:            ;calc col
         push     ebp
         push     word[esi+36]   ; -  shines
         push     word[esi+12]   ; b  orginal color
         push     word[esi+14]   ; g
         push     word[esi+16]   ; r
         push     word[esi+28]   ; b  max color
         push     word[esi+30]   ; g
         push     word[esi+32]   ; r
         push     word[esi+20]   ; b  min col
         push     word[esi+22]   ; g
         push     word[esi+24]   ; r
         push     eax         ; earlier - dot pr
      ;  fstp     .dot_product
      ;  push     .dot_product
         call     calc_one_col
         pop      ebp
         ; eax-0x00rrggbb
         cmp      al,.col_b
         jbe      @f
         mov      .col_b,al
   @@:
         shr      ax,8
         cmp      al,.col_g
         jbe      @f
         mov      .col_g,al
   @@:
         shr      eax,16
         cmp      al,.col_r
         jbe      @f
         mov      .col_r,al
  @@:
 .update_counters:                                  ; update and jump when neccesery
        add     ebx,LIGHT_SIZE
        cmp     bx,[all_lights_size]
        jl      .light    ; next_light
        mov     eax,dword .col_b
        stosd

        inc     cx
        cmp     cx,TEX_X / 2 ;256
        jne     .ie_hor

        inc     dx
        cmp     dx,TEX_X / 2 ;256
        jne     .ie_ver

    .env_done:
         mov     esp,ebp
         pop     ebp

ret


init_envmap2:         ; do env_map
;env_map 512 x 512 x 4 bytes
.temp  equ word   [ebp-2]
.nEy   equ word   [ebp-4]
.nEx   equ word   [ebp-6]
.col_r equ        [ebp-8]
.col_g equ        [ebp-9]
.col_b equ        [ebp-10]

         push     ebp
         mov      ebp,esp
         sub      esp,20
         mov      edi,envmap
         fninit

         mov      dx,- TEX_Y / 2 ;256   ; dx - vertical coordinate = y
    .ie_ver:
         mov      cx,- TEX_X / 2 ;256   ; cx - horizontal coord = x
    .ie_hor:
         xor      ebx,ebx
         mov      dword .col_b, 0
     .light:
         lea      esi,[lights+ebx]
         fld      dword[esi]     ; light vector x cooficient
         fimul    [tex_x_div2] ;[i256]
         mov      .temp,cx
         fisubr   .temp
         fistp    .nEx
         fld      dword[esi+4]   ; light vector y cooficient
         fimul    [tex_y_div2] ;[i256]
         mov      .temp,dx
         fisubr   .temp
         fistp    .nEy

         cmp      .nEx,- TEX_X / 2 ;256
         jl       .update_counters
         cmp      .nEy,- TEX_Y / 2 ;256
         jl       .update_counters
         cmp      .nEx,TEX_X / 2 ;256
         jg       .update_counters
         cmp      .nEy,TEX_Y / 2 ;256
         jg       .update_counters

         fild     .nEx
         fmul     st,st0
         fild     .nEy
         fmul     st,st0
         faddp
         fsqrt
         fisubr   [i256]
         fmul     [env_const]
         fidiv    [i256]   ; st - 'virtual' dot product

         fcom     dword[dot_max]
         fstsw    ax
         sahf
         jb       @f
         ffree    st
         fld1     ;[dot_max]
      @@:
         fcom     dword[dot_min]
         fstsw    ax
         sahf
         ja       @f
         ffree    st
         fldz     ;[dot_min]
      @@:
         push     ebp
         push     word[esi+36]   ; -  shines
         push     word[esi+12]   ; b  orginal color
         push     word[esi+14]   ; g
         push     word[esi+16]   ; r
         push     word[esi+28]   ; b  max color
         push     word[esi+30]   ; g
         push     word[esi+32]   ; r
         push     word[esi+20]   ; b  min col
         push     word[esi+22]   ; g
         push     word[esi+24]   ; r
         push     eax            ;    earlier - dot pr
      ;  fstp     .dot_product
      ;  push     .dot_product
         call     calc_one_col
         pop      ebp
         ; eax-0x00rrggbb
         cmp      al,.col_b
         jbe      @f
         mov      .col_b,al
   @@:                        ;  eax - ggbb00rr
         shr      ax,8
         cmp      al,.col_g
         jbe      @f
         mov      .col_g,al
   @@:                        ;  eax - bb0000gg
         shr      eax,16
         cmp      al,.col_r
         jbe      @f
         mov      .col_r,al
   @@:
   .update_counters:                     ; update and jump when neccesery
         add      ebx,LIGHT_SIZE
         cmp      bx,[all_lights_size]
         jl       .light    ; next_light
         mov      eax,dword .col_b
         or        eax,0xff000000
         stosd
     ;    dec      edi

         inc      cx
         cmp      cx,TEX_X / 2 ;256
         jne      .ie_hor

         inc      dx
         cmp      dx,TEX_Y / 2 ;256
         jne     .ie_ver

         mov     esp,ebp
         pop     ebp
ret


  calc_one_col:
; procedure don't save registers !!!
; in -   st - dot_product
;        stack - other parameters
; out - eax - 0x00rrggbb
.dot_prd   equ dword[ebp+4]           ; dot product   - cos x  - not now
.min_col_r equ word[ebp+8]            ; minimum color - ambient
.min_col_g equ word[ebp+10]
.min_col_b equ word[ebp+12]
.max_col_r equ word[ebp+14]           ; maximum color - specular
.max_col_g equ word[ebp+16]
.max_col_b equ word[ebp+18]
.org_col_r equ word[ebp+20]           ; orginal color - diffuse
.org_col_g equ word[ebp+22]
.org_col_b equ word[ebp+24]
.n         equ word[ebp+26]           ; shines - not implemented
.temp      equ word[ebp-2]
.color_sum_r equ dword[ebp-6]
.color_sum_g equ dword[ebp-10]
.color_sum_b equ dword[ebp-14]
; color = ambient+cos(x)*diffuse+(cos(x)^n)*specular
         mov     ebp,esp
         sub     esp,14

         mov      ax,.min_col_r
         add      ax,.max_col_r
         add      ax,.org_col_r
         cwde
         mov      .color_sum_r,eax

         mov      ax,.min_col_g
         add      ax,.max_col_g
         add      ax,.org_col_g
         cwde
         mov      .color_sum_g,eax

         mov      ax,.min_col_b
         add      ax,.max_col_b
         add      ax,.org_col_b
         cwde
         mov      .color_sum_b,eax


;         fld     .dot_prd
       ;  fild    .n
       ;  fxch    st1
       ;  fabs
       ;  fyl2x                     ;
       ;  f2xm1
       ;  fld1
       ;  faddp        ; st =  dot_product ^ n

         fld     st            ; copy dot pr
         fmul    st,st0
         fmul    st,st0
         fmul    st,st0
         cmp     .n,255            ; .n = 255 -> spot light
         jne     @f
         fmul    st,st0
         fmul    st,st0
         fmul    st,st0
      @@:
         fld     st            ; st0=st1=dot_pr^n, st2=dot_pr
         fimul   .max_col_b
         fild    .org_col_b
         fmul    st,st3
         faddp                 ; st0=first piece of col, st1=dot_pr^n..
         fiadd   .min_col_b
         fimul   .max_col_b
         fidiv   .color_sum_b
         fistp   .temp
         movzx   eax,.temp
         shl     eax,16

         fld     st
         fimul   .max_col_g
         fild    .org_col_g
         fmul    st,st3
         faddp
         fiadd   .min_col_g
         fimul   .max_col_g
         fidiv   .color_sum_g
         fistp   .temp
         mov     ax,.temp
         mov     ah,al
         shl     eax,8

         fimul   .max_col_r
         fild    .org_col_r
         fmulp   st2,st
         faddp
         fiadd   .min_col_r
         fimul   .max_col_r
         fidiv   .color_sum_r
         fistp   .temp
         mov     ax,.temp          ;eax -  0xbbgg00rr
     ;   mov     ah,al
         ror     eax,16
         xchg    al,ah             ; eax - 0x00rrggbb
         mov     esp,ebp
ret 24
